/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: IDescription.java,v 1.2 2006/01/05 02:19:17 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt;

public interface IDescription {

	/**
	 * This method should return a string in either plain text or html
	 * that describes exhaustivly the purpose, behaviour and usage. 
	 * The returned information will be displayed in the Info frame of the GUI.
	 * The sender object can be queried to get information about the caller of this
	 * class. For now sender will be null, so you can just ignore this parameter.
	 * @param sender the object which calls this method, may be null
	 * @return string
	 */
	public String getClassDescription(Object sender);
	
}
