package prompt.contexthints;

import java.io.Serializable;
import java.util.HashMap;

import tschmidt.utils.HashTools;

public class HintStates implements Serializable {


	private static final long serialVersionUID = 1L;
	
	//Zeiger auf eine HashMap, wird von GUIPreferences umgebogen (in loadPreferences)
	public static HashMap<String,Boolean> showState = new HashMap<String,Boolean>();
	
	/**
	 * @param name
	 * @param state boolean: true falls der hint angezeigt werden soll,
	 * false falls nicht mehr.
	 */
	public static void setState(String name, boolean state) {
		showState.put(name,Boolean.valueOf(state));
	}
	
	/**
	 * @param name
	 * @return true if the hint shall be shown
	 */
	public static boolean getState(String name) {
		Boolean bool = showState.get(name);
		if (bool==null) return true;
		return bool.booleanValue();
	}
	
	public static String showStates() {
		if (showState==null)  return "leer";
		return HashTools.showHash(showState);
	}
	
}
