/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: Engine1.java,v 1.2 2006/01/05 02:19:15 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.engine;

import prompt.input.IInput;

/**
 * @author Schmidt
 *
 */
public abstract class Engine1 extends Engine implements IEngine1 {
  private final static long serialVersionUID = -6849794470754667700L;
    /**
	 *	As there is only one input dataset, there is only one description. So both descriptions<br>
	 *	fields <code>desc1</code> and <code>desc2</code> have the same value.
	 */
	/* (non-Javadoc)
	 * @see de.tum.binfo.proj.engine.IEngine1#init(de.tum.binfo.proj.input.IInput)
	 */
	public void init(IInput setA) throws Exception {
		if (setA == null) {
			throw new Exception("Dataset setA is null");
		}
		desc1 = setA.getDescription();

	}
}
