package prompt.engine;

import gr.zeus.ui.JMessage;

import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.util.ArrayList;

import javax.swing.JOptionPane;

import org.apache.log4j.Logger;

import prompt.gui.dlgs.ResultFilterFrame;

public class ResultFilterDlg extends ResultFilterFrame {

	private Logger logger = Logger.getLogger(this.getClass());
	private static final long serialVersionUID = 1L;

	public boolean cancel = true;
	public String sqlcmd = null;
	
	public ResultFilterDlg(Frame arg0, boolean arg1) {
		super(arg0, arg1);
		
		if ((cmds!=null) && (cmds.size()>0)) {
			for (int i = 0; i < cmds.size(); i++) {
				String oldcmd = (String) cmds.get(i);
				logger.debug("add item '"+oldcmd+"'");
				comboboxSQL.addItem(oldcmd);	
			}
		}
	}

	@Override
	public void btnCancelActionPerformed(ActionEvent arg0) {
		super.btnCancelActionPerformed(arg0);
		dispose();
		
	}

	static ArrayList cmds = new ArrayList();
	
	@Override
	public void btnOkActionPerformed(ActionEvent arg0) {
		super.btnOkActionPerformed(arg0);
		cancel = false;
		sqlcmd = (String)comboboxSQL.getSelectedItem();
		logger.debug("SQLcmd='"+sqlcmd+"'");
		if (((sqlcmd==null)) || (sqlcmd.length()==0)) {
			JMessage.showMessageDialog(null, "You must enter a filter query",
					JOptionPane.WARNING_MESSAGE, JOptionPane.DEFAULT_OPTION);
			return;
		}
		cmds = new ArrayList();
		cmds.add(sqlcmd);
		int anz = comboboxSQL.getItemCount();
		for (int i = 0; i < anz; i++) {
			String currentCmd = (String) comboboxSQL.getItemAt(i);
			logger.debug("currentCmd='"+currentCmd+"'");
			cmds.add(currentCmd);
		}
		dispose();
		
	}

	
	
	
}
