package prompt.engine.applymapping;

import gr.zeus.ui.JMessage;

import javax.swing.JOptionPane;

import org.apache.log4j.Logger;

import prompt.engine.IEngine2;
import prompt.engine.genericxml.ExportFeatureToXmlFile;
import prompt.engine.genericxml.GenericHelper;
import prompt.input.IGenericProperty;
import prompt.input.IGenericXML;
import prompt.input.IInput;
import prompt.ui.DialogFactory;

/*
 * Created on 20.01.2006
 * wie prompt.engine.genericxml.ExportFeatureToXMLFile
 * nur das alle IDs fuer die wir mapping infos vorliegen
 * haben durch die gemappten Ids ersetzt werden.
 * Ist fuer eine ID keine Mapping Info vorhanden dann wird
 * der Benutzer gefragt ob er diese Info rausschreiben will oder
 * weglassen soll.
 * 
 */

public class ExportXMLMapped extends ExportFeatureToXmlFile implements IEngine2 {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * mapping object, specify additionall with the setMappingSet
	 */
	protected IGenericXML set2;

	/**
	 * The description ofthe mapping set. 
	 */
	String choosenSet;

	//ODER direkt mappingProperty

	IGenericProperty mappingProperty;

	public void init(IInput setA, IInput setB) throws Exception {
		try { 
			init(setA);
			this.set2 = (IGenericXML) setB;
		} catch (Exception e) {
		 throw new ClassCastException("<html>You need 2 Input objects for this method that contain generic properties.<br>" +
		 		"One of these inputs must contain a symbolic property with the mapping assignments");
		}
		
	}
	Logger logger = Logger.getLogger(this.getClass());
	@Override
	public void run() throws Exception {
		
		if (mappingProperty == null) {

			if (choosenSet == null) {
				choosenSet = DialogFactory.chooseDlg("Which object contains the mapping assignments",
						"Choose the set that contains the mapping information", new String[] { set.getDescription(), set2.getDescription() }, set2
								.getDescription());

				if (choosenSet == null) {
					String errmsg = "Canceled by user: Not choosen which set contains the mapping info";
					logger.info(errmsg);
					JMessage.showMessageDialog(null, errmsg, JOptionPane.WARNING_MESSAGE, JOptionPane.DEFAULT_OPTION);
					return;
				}
				if (!choosenSet.equals(set2.getDescription())) {
					IGenericXML tmp = set;
					set = set2;
					set2 = tmp;
				}
			}
			//jetzt die Property asuwaehlen die die Mapping Infos enthaelt
			mappingProperty=GenericHelper.getProperty(set2, IGenericProperty.SYMBOLIC);
		}
		if (mappingProperty==null) {
			String errmsg = "Canceled: No mapping property is choosen";
			logger.info(errmsg);
			JMessage.showMessageDialog(null, errmsg, JOptionPane.WARNING_MESSAGE, JOptionPane.DEFAULT_OPTION);
			return;
		}
		if (mappingProperty.getValues().size()==0) {
			String errmsg = "Canceled: The choosen mapping property has no elements";
			logger.info(errmsg);
			JMessage.showMessageDialog(null, errmsg, JOptionPane.WARNING_MESSAGE, JOptionPane.DEFAULT_OPTION);
			return;
		}
		
		super.run();
		
	}

	/*TODO: 
	 * - setter that save the information what we shall do if mapping info
	 is missing
	 */


	
	@Override
	public Object replaceIds(Object id) {
		Object oldid = id;
		//logger.debug(mappingProperty.getValues());
		//HashTools.showHash(mappingProperty.getValues());
		
		Object newid = mappingProperty.getValues().get(id);
		logger.debug("replace oldid='"+oldid+"' with '"+newid+"'");
		
		return newid;
	}

	public IGenericProperty getMappingProperty() {
		return mappingProperty;
	}

	public void setMappingProperty(IGenericProperty mappingProperty) {
		this.mappingProperty = mappingProperty;
	}

}
