/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: CmpNumeric1.java,v 1.5 2006/03/19 11:58:08 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.engine.genericxml;

import java.util.ArrayList;

import org.apache.log4j.Logger;

import prompt.engine.CompareNumericDistributions;
import prompt.engine.Engine1;
import prompt.engine.IEngineResults;
import prompt.input.IGenericProperty;
import prompt.input.IGenericXML;
import prompt.input.IInput;



public class CmpNumeric1 extends Engine1 {

    protected IGenericXML setA;
    private Logger logger = Logger.getLogger(this.getClass());
    private static final long serialVersionUID = 1L;
    ArrayList allResults = new ArrayList();
    
    public CmpNumeric1() {
        super();
    }

    public void init(IInput setA) throws Exception {
        super.init(setA);
        this.setA = (IGenericXML) setA;
       
    }
    
    private void cmpNumeric(IGenericProperty property1, IGenericProperty property2) throws Exception {
      //get the numeric values of both sets
        Object[] values1 = property1.getValues().values().toArray();
        Object[] values2 = property2.getValues().values().toArray();
        CompareNumericDistributions cmp = new CompareNumericDistributions();
        cmp.init("Compare:numeric",
                property1.getId()+" | "+setA.getDescription(),property2.getId()+" | "+setA.getDescription(), values1,values2,null);
        cmp.run();
        IEngineResults[] res = cmp.getResultsAll();
        for (int i = 0; i < res.length; i++) {
            IEngineResults curRes = res[i];
            if (!((curRes+"").equals("null")))  { //oh nein open source argl,           
                allResults.add(curRes);
               // logger.debug("i="+i+" "+curRes.getData());
            } else {
                logger.debug("i="+i+" null result");
            }
        }
    }



    

    
    @Override
    public void run() throws Exception {
       //FIXME: if setA and setB are not yet set, then ask the user
        
        IGenericProperty  propA = GenericHelper.getProperty(setA,IGenericProperty.NUMERIC);
        if (propA==null) return;
        IGenericProperty  propB = GenericHelper.getProperty(setA,IGenericProperty.NUMERIC);
        if (propB==null) return;
        allResults = new ArrayList();
        cmpNumeric(propA,propB);
        
    }
    
    public IEngineResults[] getResultsAll() throws Exception {
        logger.debug("allResults.size():"+allResults.size());
        //nur results die nicht null sind sollen zurueck
         ArrayList tmp = new ArrayList();
        
         for (int i = 0; i < allResults.size(); i++) {
            IEngineResults curRes = (IEngineResults) allResults.get(i);
            if (!((curRes+"").equals("null")))  { //oh nein open source argl,
            //logger.debug("BB"+curRes.getData());
            tmp.add(curRes);
         
            }
         }
            logger.debug("tmp.size():"+tmp.size());
         IEngineResults[] results = new IEngineResults[tmp.size()];
         for (int j = 0; j < tmp.size(); j++) {
            results[j] = (IEngineResults) tmp.get(j);
        }
         
         return results;
    }
}
