/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universit�t M�nchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: CorNumeric1.java,v 1.5 2006/01/12 15:21:12 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.engine.genericxml;

import org.apache.log4j.Logger;

import prompt.engine.Engine1;
import prompt.engine.IEngineResults;
import prompt.input.IGenericProperty;
import prompt.input.IGenericXML;
import prompt.input.IInput;


public class CorNumeric1 extends Engine1 {
    
    protected IGenericXML setA;
    private Logger logger = Logger.getLogger(this.getClass());
    private static final long serialVersionUID = 1L;  
    
    public void init(IInput setA) throws Exception {
        super.init(setA);
        this.setA = (IGenericXML) setA;
    }
    


    IEngineResults[] res; 
    
    @Override
    public void run() throws Exception {
        IGenericProperty  propA = GenericHelper.getProperty(setA,IGenericProperty.NUMERIC);
        if (propA==null) return;
        IGenericProperty  propB = GenericHelper.getProperty(setA,IGenericProperty.NUMERIC);
        if (propB==null) return;
        
        String comparisonName = this.getClass().getName();
        String descA = propA.getId();
        String descB = propB.getId();
        IEngineResults[] ret = CorNumeric2.corNumeric(propA,propB,descA,descB,comparisonName);
        if (ret==null) return;
        res= ret;

    }

    @Override
    public IEngineResults[] getResultsAll() throws Exception {
        return res;
    }
    
}
