/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: FeatFrq.java,v 1.5 2006/03/19 11:58:08 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.engine.genericxml;

import java.util.HashMap;

import prompt.engine.Counter;
import prompt.engine.Engine1;
import prompt.input.IGenericProperty;
import prompt.input.IGenericXML;
import prompt.input.IInput;


public class FeatFrq extends Engine1{

    protected IGenericXML set;
    
    private static final long serialVersionUID = 1L;
    String resultStr = null;


    public void init(IInput set) throws Exception {
        super.init(set);
        this.set = (IGenericXML) set;
     
    }
    


    @Override
    public void run() throws Exception {
        IGenericProperty  prop = GenericHelper.getProperty(set,IGenericProperty.SYMBOLIC);
        if (prop==null) return;
        this.desc2=prop.getId();
        HashMap ids = prop.getValues();
        
        //resultStr = Counter.buildResString(ids, null, prop.getValues().size());
        resultStr = Counter.buildResStringSimple(ids);
        //oder
        //resultStr = Counter.buildResString(ids,null,set.getSequenceNames.size());
    }
    
    
    public String toString() {
        return resultStr;
    }
}
