package prompt.engine.genericxml;


import java.util.ArrayList;

import gr.zeus.ui.JMessage;

import javax.swing.JOptionPane;

import org.apache.log4j.Logger;

import prompt.engine.Engine2;
import prompt.engine.IEngineResults;
import prompt.input.IGenericProperty;
import prompt.input.IGenericXML;
import prompt.input.IInput;

public class MultiCor2 extends Engine2 {

	protected IGenericXML setA;

	protected IGenericXML setB;

	@Override
	public void init(IInput setA, IInput setB) throws Exception {
		// TODO Auto-generated method stub
		super.init(setA, setB);
		this.setA = (IGenericXML) setA;
		this.setB = (IGenericXML) setB;
	}

	IEngineResults[] resAll;

	@Override
	public IEngineResults[] getResultsAll() throws Exception {
		return resAll;
	}

	IGenericProperty[] propArrayA;
	IGenericProperty[] propArrayB;
	
	
	public static IEngineResults[] corr(IGenericProperty[] propArrayAA,IGenericProperty[] propArrayBB,String descA,String descB, String comparisonName) {
		int anzA = propArrayAA.length;
		int anzB = propArrayBB.length;
		Logger logger = Logger.getLogger(ExportFeatureToXmlFile.class.getName());
		logger.debug(anzA + " number of properties choosen in A");
		logger.debug(anzB + " number of properties choosen in B");

		ArrayList<IEngineResults> all = new ArrayList<IEngineResults>();
		//String comparisonName =MultiCor2.class.getName();
		 
		for (int i = 0; i < anzA; i++) {
			IGenericProperty elA = propArrayAA[i];
			for (int j = i; j < anzB; j++) {
				IGenericProperty elB = propArrayBB[j];
					String descAA = descA+":"+elA.getId();
			        String descBB = descB+":"+elB.getId();
				
					IEngineResults[] res=null;
					try {
						res = CorNumeric2.corNumeric(elA,elB,descAA,descBB,comparisonName);
					} catch (Exception e) {
						logger.error(e);
					}
					if (res!=null) {
					for (IEngineResults results : res) {
						if ((results.getData()!=null) && (results.getData().trim().length()>5))
						all.add(results);
					}
					}
				
			}
		}
		IEngineResults[] resAll2 = new IEngineResults[all.size()];
		for (int i = 0; i < resAll2.length; i++) {
			resAll2[i] = all.get(i);
		}
		return resAll2;
	}

	@Override
	public void run() throws Exception {
		Logger logger = Logger.getLogger(this.getClass().getName());

		// properties aus setA
		if ((propArrayA == null) || (propArrayA.length < 1)) {
			propArrayA = GenericHelper.getProperties(setA, IGenericProperty.NUMERIC);
		}

		if ((propArrayA == null) || (propArrayA.length == 0)) {
			String errmsg = "Canceled because no feature(s) was/were choosen)";
			logger.fatal(errmsg);
			JMessage.showMessageDialog(null, errmsg, JOptionPane.ERROR_MESSAGE, JOptionPane.DEFAULT_OPTION);
			return;
		}

		// properties aus setB
		if ((propArrayB == null) || (propArrayB.length < 1)) {
			propArrayB = GenericHelper.getProperties(setB, IGenericProperty.NUMERIC);
		}

		if ((propArrayB == null) || (propArrayB.length == 0)) {
			String errmsg = "Canceled because no feature(s) was/were choosen)";
			logger.fatal(errmsg);
			JMessage.showMessageDialog(null, errmsg, JOptionPane.ERROR_MESSAGE, JOptionPane.DEFAULT_OPTION);
			return;
		}
		String descA = setA.getDescription();
        String descB = setB.getDescription();
        resAll = corr(propArrayA,propArrayB,descA,descB,this.getClass().getName());
        

	}

	public void setPropArrayA(IGenericProperty[] propArrayA) {
		this.propArrayA = propArrayA;
	}

	public void setPropArrayB(IGenericProperty[] propArrayB) {
		this.propArrayB = propArrayB;
	}

}
