package prompt.engine.genericxml;


import java.util.ArrayList;

import gr.zeus.ui.JMessage;

import javax.swing.JOptionPane;

import org.apache.log4j.Logger;

import prompt.engine.Engine2;
import prompt.engine.IEngineResults;
import prompt.input.IGenericProperty;
import prompt.input.IGenericXML;
import prompt.input.IInput;

public class MultiSymbolic extends Engine2 {

	protected IGenericXML setA;

	protected IGenericXML setB;

	@Override
	public void init(IInput setA, IInput setB) throws Exception {
		// TODO Auto-generated method stub
		super.init(setA, setB);
		this.setA = (IGenericXML) setA;
		this.setB = (IGenericXML) setB;
	}

	IEngineResults[] resAll;

	@Override
	public IEngineResults[] getResultsAll() throws Exception {
		return resAll;
	}

	IGenericProperty propArrayA[];

	IGenericProperty propArrayB[];

	@Override
	public void run() throws Exception {
		Logger logger = Logger.getLogger(ExportFeatureToXmlFile.class.getName());

		// properties aus setA
		if ((propArrayA == null) || (propArrayA.length < 1)) {
			propArrayA = GenericHelper.getProperties(setA, IGenericProperty.SYMBOLIC);
		}

		if ((propArrayA == null) || (propArrayA.length == 0)) {
			String errmsg = "Canceled because no feature(s) was/were choosen)";
			logger.fatal(errmsg);
			JMessage.showMessageDialog(null, errmsg, JOptionPane.ERROR_MESSAGE, JOptionPane.DEFAULT_OPTION);
			return;
		}

		// properties aus setB
		if ((propArrayB == null) || (propArrayB.length < 1)) {
			propArrayB = GenericHelper.getProperties(setB, IGenericProperty.SYMBOLIC);
		}

		if ((propArrayB == null) || (propArrayB.length == 0)) {
			String errmsg = "Canceled because no feature(s) was/were choosen)";
			logger.fatal(errmsg);
			JMessage.showMessageDialog(null, errmsg, JOptionPane.ERROR_MESSAGE, JOptionPane.DEFAULT_OPTION);
			return;
		}

		int anzA = propArrayA.length;
		int anzB = propArrayB.length;
		logger.debug(anzA + " number of properties choosen in A");
		logger.debug(anzB + " number of properties choosen in B");

		ArrayList<IEngineResults> all = new ArrayList<IEngineResults>();

		for (int i = 0; i < anzA; i++) {
			IGenericProperty elA = propArrayA[i];
			for (int j = 0; j < anzB; j++) {
				IGenericProperty elB = propArrayB[j];
			//	if (elA.getId().equalsIgnoreCase(elB.getId())) {
					CmpSymb cmp = new CmpSymb();
					cmp.init(setA, setB);
					cmp.cmpSymbolic(elA, elB);
					IEngineResults[] res = cmp.getResultsAll();
					if (res!=null) {
					for (IEngineResults results : res) {
						if ((results.getData()!=null) && (results.getData().trim().length()>5))
						all.add(results);
					}
					}
				//}
			}
		}
		resAll = new IEngineResults[all.size()];
		for (int i = 0; i < resAll.length; i++) {
			resAll[i] = all.get(i);
		}

	}

	public void setPropArrayA(IGenericProperty[] propArrayA) {
		this.propArrayA = propArrayA;
	}

	public void setPropArrayB(IGenericProperty[] propArrayB) {
		this.propArrayB = propArrayB;
	}

}
