package prompt.engine.genericxml;

import gr.zeus.ui.JMessage;

import java.io.File;

import javax.swing.JOptionPane;

import org.apache.log4j.Logger;

import prompt.engine.Engine;
import prompt.input.IInput;
import prompt.input.classes.GenericXMLFile;
import prompt.ui.SaveUI;

public class Weka extends Engine {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	GenericXMLFile[] in = null;
	
	@Override
	public void run() throws Exception {
		 Logger logger = Logger.getLogger(Txt2Xml.class.getName());
		 String srcFileName = SaveUI.load("Load a WEKA arff file", ".arff");   
		 if (srcFileName == null) {
	        String errmsg = "Converting canceled (no src file choosen)";
	        logger.fatal(errmsg);
	        JMessage.showMessageDialog(null, errmsg, JOptionPane.ERROR_MESSAGE, JOptionPane.DEFAULT_OPTION);
	        return;
	    }
		logger.debug("src file='"+srcFileName+"'"); 
		Weka2Xml converter = new Weka2Xml();
		File f2 = new File(srcFileName);
		logger.debug(f2.getName());
	    File f = File.createTempFile(f2.getName()+"_","");
	    converter.setDestFileNamePrefix(f.getAbsolutePath());
	    converter.setSrcFileName(srcFileName);
	    converter.run();
	    
	    if (converter.hasWorked()) {
			in = new GenericXMLFile[converter.resultFiles.length];
			for (int i = 0; i < converter.resultFiles.length; i++) {
				String fname = converter.resultFiles[i];
				
				in[i] = new GenericXMLFile();
				in[i].init(fname);
				in[i].run();
			}
			
		//	logger.debug(in.toString());
		}
	    
	}

	@Override
	public IInput[] getInputsAll() throws Exception {
		return in;
	}

	
	
    @Override
    public String toString() {
        return null;
    }
	
}
