/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: AaDistributionDimer.java,v 1.7 2006/03/19 11:57:57 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.engine.seqproperties;

import java.util.Enumeration;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Vector;

import org.apache.log4j.Logger;
import org.biojava.bio.seq.SequenceIterator;

import prompt.input.IInput;
import tschmidt.utils.PatternTools;




public class AaDistributionDimer extends SeqCheck2 {
  private final static long serialVersionUID = -6849794470754667700L;
  Logger logger = Logger.getLogger(AaDistribution.class);

	

	public Hashtable vecHashA = new Hashtable(); // element -> vector with frequencies
	public Hashtable vecHashB = new Hashtable();
	//protected Input setA, setB;
	public SequenceIterator iter1, iter2;



	/**
	 * @param setA
	 * @param setB
	 * @throws Exception
	 */
	public void init(IInput setA, IInput setB) throws Exception {
		super.init(setA, setB);
		

	}

	public void countAminoAcids() {

		//	int actValue;

		Iterator iter1 = seqA.iterator();
		while (iter1.hasNext()) {
			String ssq = (String) iter1.next();
			if (ssq!=null) {
			HashMap tmphash = new HashMap();
			int anzahl = PatternTools.countPattern(tmphash, ssq, 2);
			
			PatternTools.divHashMap(tmphash,anzahl);
			
			
			Iterator enu = tmphash.keySet().iterator();
			//float len = (new Integer(ssq.length())).floatValue();
			while (enu.hasNext()) {
				String thisKey = (String) enu.next();
	
				if (vecHashA.containsKey(thisKey)) {
					((Vector) vecHashA.get(thisKey)).addElement(
					new Double(((Double)tmphash.get(thisKey)).doubleValue()));
				} else {
					vecHashA.put(thisKey, new Vector());
					((Vector) vecHashA.get(thisKey)).addElement(
					new Double(((Double)tmphash.get(thisKey)).doubleValue()));
				}
			}
			tmphash.clear();
			}
		}

		Iterator iter2 = seqB.iterator();
		while (iter2.hasNext()) {
			String ssq = (String) iter2.next();
			if (ssq!=null) {
			HashMap tmphash = new HashMap();
			int anzahl = PatternTools.countPattern(tmphash, ssq, 2);
			PatternTools.divHashMap(tmphash,anzahl);
			
		
			Iterator enu = tmphash.keySet().iterator();
			//float len = (new Integer(ssq.length())).floatValue();
			while (enu.hasNext()) {
				String thisKey = (String) enu.next();
	
				if (vecHashB.containsKey(thisKey)) {
					((Vector) vecHashB.get(thisKey)).addElement(
					new Double(((Double)tmphash.get(thisKey)).doubleValue()));
				} else {
					vecHashB.put(thisKey, new Vector());
					((Vector) vecHashB.get(thisKey)).addElement(
					new Double(((Double)tmphash.get(thisKey)).doubleValue()));
				}
			}
			tmphash.clear();
			}
		}

	}
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		StringBuffer strBuff = new StringBuffer();
		strBuff.append("DATASET\tAA\tFREQ\n");


		//Ausgabe
		Enumeration enu = vecHashA.keys();
		while (enu.hasMoreElements()) {
			String thisKey =  (String) enu.nextElement();
		

		Vector actAA = (Vector) vecHashA.get(thisKey);
			for (int j = 0; j < actAA.size(); j++) {
				strBuff.append(
					"setA\t" + thisKey + "\t" + actAA.elementAt(j) + "\n");
			}
		}

		enu = vecHashB.keys();
		while (enu.hasMoreElements()) {
			String thisKey = (String) enu.nextElement();

			Vector actAA = (Vector) vecHashB.get(thisKey);
			for (int j = 0; j < actAA.size(); j++) {
				strBuff.append(
					"setB\t" + thisKey + "\t" + actAA.elementAt(j) + "\n");
			}
		}
		//logger.debug(strBuff.toString());
		return strBuff.toString();
	}



	/* (non-Javadoc)
	 * @see de.tum.binfo.jdrm.JobTemplate#run()
	 */
	public void run() throws Exception {
		countAminoAcids();
	}

}
