/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: PIabs.java,v 1.6 2006/03/19 11:57:58 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.engine.seqproperties;

import java.util.Iterator;
import java.util.List;

import org.apache.log4j.Logger;
import org.biojava.bio.BioException;
import org.biojava.bio.symbol.IllegalAlphabetException;

import prompt.input.IInput;
import prompt.input.ISeqProperties;



/**
 * @author schmidt
 * List of Math.abs(PI-7) values
 */
public class PIabs extends SeqCheck1 {
  private final static long serialVersionUID = -6849794470754667700L;
  Logger logger = Logger.getLogger(PIabs.class);
  ISeqProperties set;
  
   
   public PIabs()
   {
     super();
   }
   
	public void init(IInput setA) throws Exception {
	  
	  super.init(setA);
	 
	  set = (ISeqProperties) setA;
	  seqA = null;
	}
  
  /* (non-Javadoc)
   * @see java.lang.Object#toString()
   */
  public String toString() {
      Logger logger = Logger.getLogger(this.getClass());
    StringBuffer ret = new StringBuffer();
    List list = null;
    try {
      list = set.getPI();
    } catch (IllegalAlphabetException e) {
        logger.error(e);
    } catch (BioException e) {
        logger.error(e);
    }
    ret.append("\"abs(pI-7)\"\n");
    for (Iterator iter = list.iterator(); iter.hasNext();) {
      Double dd = (Double) iter.next();
      double d = dd.doubleValue();
      double a = Math.abs(d-7d);
      ret.append(a+"\n");
    }
   
    return ret.toString();
  }



  /* (non-Javadoc)
   * @see de.tum.binfo.jdrm.JobTemplate#run()
   */
  public void run() throws Exception {
    
  }

}
