
package prompt.engine.seqproperties;

import java.util.List;

import prompt.engine.Engine1;
import prompt.input.IGenericXMLFile;
import prompt.input.IInput;
import prompt.input.ISeqProperties;
/*
 * Created on 06.01.2006
 *
 */

public abstract class SeqCheck1 extends Engine1 {
    protected ISeqProperties setA, setB;
    List seqA;

    List seqB;
    
    public void init(IInput setA) throws Exception {
    	super.init(setA);
        try {
            this.setA = ((ISeqProperties) setA);
        } catch (ClassCastException e) {
           String errmsg = "The input '"+setA.getDescription()+" must be able to provide sequences";
           throw new ClassCastException(errmsg);
        }        

        seqA = this.setA.getSequences();
        if ((seqA==null) || (seqA.size()==0)) {
            String errmsg="<b>The input '"+setA.getDescription()+"' does not contain any sequences</b>";
            if (IGenericXMLFile.class.isAssignableFrom(setA.getClass())) {
                errmsg = errmsg +"<br>The Generic XML file needs a <b>setdef</b> property that defines " +
                        "the proteins within the set,<br> and must contain sequences for this analysis";
            }
            throw new ClassCastException(errmsg);
        }
        

    }
}
