/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: BlastDialog.java,v 1.5 2006/03/19 11:58:10 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.engine.seqproperties.mapper;

import java.util.Enumeration;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

import org.apache.log4j.Logger;

/**
 * ziemlicher bullshit, aber eclipse's visual editor
 * ist ja auch nur 10 Jahre Delphi hinterher.
 * @author tschmidt
 *
 */
public class BlastDialog {

    Logger logger = Logger.getLogger(this.getClass());
	private JDialog jDialog = null;  //  @jve:decl-index=0:visual-constraint="29,32"
	private JPanel jContentPane = null;
	private JButton btn_ok = null;
	private JButton btn_cancel = null;
	private JLabel jLabel = null;
	public static JRadioButton rdo_btn_setA = null;
	public JRadioButton rdo_btn_setB = null;
	private JLabel label_desc1 = null;
	private JLabel label_desc2 = null;
	private JLabel jLabel1 = null;
	private JTextField jTextField = null;
	private JLabel jLabel2 = null;
	public JRadioButton rdo_btn_protein = null;
	public JRadioButton rdo_btn_nucleo = null;
	private JLabel jLabel3 = null;
	private JLabel jLabel4 = null;
	private JLabel jLabel5 = null;
	private JLabel jLabel6 = null;
	private JLabel jLabel7 = null;
	/**
	 * This method initializes jDialog	
	 * 	
	 * @return javax.swing.JDialog	
	 */
	private JDialog getJDialog() {
		if (jDialog == null) {
			jDialog = new JDialog();
			jDialog.setSize(new java.awt.Dimension(613,477));
			jDialog.setModal(true);
			jDialog.setTitle("Blast Settings");
			jDialog.setContentPane(getJContentPane());
		}
		group1 = new ButtonGroup();
		rdo_btn_setA.setSelected(true);
		rdo_btn_setB.setSelected(false);
		group1.add(rdo_btn_setA);
		group1.add(rdo_btn_setB);
		
		
	    group2 = new ButtonGroup();
	    rdo_btn_protein.setSelected(true);
	    rdo_btn_nucleo.setSelected(false);
		group2.add(rdo_btn_protein);
		group2.add(rdo_btn_nucleo);
	    
	    
		return jDialog;
	}

	 public ButtonGroup group1;
	 public ButtonGroup group2;
	
	/**
	 * This method initializes jContentPane	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJContentPane() {

		
		if (jContentPane == null) {

			
			jLabel7 = new JLabel();
			jLabel7.setBounds(new java.awt.Rectangle(8,12,240,23));
			jLabel7.setText("Choose Query Set:");
			jLabel6 = new JLabel();
			jLabel6.setBounds(new java.awt.Rectangle(8,146,117,20));
			jLabel6.setText("Sequence Type:");
			jLabel5 = new JLabel();
			jLabel5.setBounds(new java.awt.Rectangle(8,270,147,22));
			jLabel5.setText("BLAST Parameter:");
			jLabel4 = new JLabel();
			jLabel4.setBounds(new java.awt.Rectangle(45,214,251,22));
			jLabel4.setText("nucleotid sequences");
			jLabel3 = new JLabel();
			jLabel3.setBounds(new java.awt.Rectangle(45,188,251,22));
			jLabel3.setText("amino acid sequences");
			jLabel2 = new JLabel();
			jLabel2.setBounds(new java.awt.Rectangle(8,159,565,32));
			jLabel2.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 12));
			jLabel2.setText("<html>Specifiy the kind of sequences. Note: All sequences in both sets must be of the same kind.</html>");
			jLabel1 = new JLabel();
			jLabel1.setBounds(new java.awt.Rectangle(8,286,584,44));
			jLabel1.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 12));
			jLabel1.setText("<html>Enter a custom parameter string for your blastall search. <b>Leave it empty to use default values!</b><br>The parameters -p, -i, -m, -b must not be set, they are included automatically.</html> ");
			label_desc2 = new JLabel();
			label_desc2.setBounds(new java.awt.Rectangle(45,91,500,22));
			label_desc2.setText("JLabel");
			label_desc1 = new JLabel();
			label_desc1.setBounds(new java.awt.Rectangle(45,67,500,22));
			label_desc1.setText("JLabel");
			jLabel = new JLabel();
			
			jLabel.setBounds(new java.awt.Rectangle(8,29,576,49));
			jLabel.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 12));
			jLabel.setText("<html>Select the protein group that should be the BLAST Query.<br>The other protein group will be automatically the database against the query is blasted.</html>");
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(getJButton(), null);
			jContentPane.add(getJButton1(), null);
			jContentPane.add(jLabel, null);
			

			jContentPane.add(label_desc1, null);
			jContentPane.add(label_desc2, null);
			jContentPane.add(jLabel1, null);
			jContentPane.add(getJTextField(), null);
			jContentPane.add(jLabel2, null);
			jContentPane.add(getRdo_btn_protein(), null);
			jContentPane.add(getRdo_btn_nucleo(), null);
			jContentPane.add(getRdo_btn_setA(), null);
			jContentPane.add(getRdo_btn_setB(), null);
			jContentPane.add(jLabel3, null);
			jContentPane.add(jLabel4, null);
			jContentPane.add(jLabel5, null);
			jContentPane.add(jLabel6, null);
			jContentPane.add(jLabel7, null);
		}
		return jContentPane;
	}

	
	boolean canceled = true;
	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton() {
		if (btn_ok == null) {
			btn_ok = new JButton();
			btn_ok.setBounds(new java.awt.Rectangle(508,400,75,30));
			btn_ok.setText("Ok");
			//btn_ok.setSelected(true);
			btn_ok.setName("btn_ok");
			btn_ok.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					logger.debug("ok()"); // TODO Auto-generated Event stub actionPerformed()
					canceled = false;
					jDialog.dispose();
				}
			});
		}
		return btn_ok;
	}

	/**
	 * This method initializes jButton1	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton1() {
		if (btn_cancel == null) {
			btn_cancel = new JButton();
			btn_cancel.setBounds(new java.awt.Rectangle(420,400,75,30));
			btn_cancel.setText("Cancel");
			btn_cancel.setToolTipText("");
			btn_cancel.setName("btn_cancel");
			btn_cancel.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					logger.debug("cancel()"); // TODO Auto-generated Event stub actionPerformed()
					jDialog.dispose();
				}
			});
		}
		return btn_cancel;
	}

	/**
	 * This method initializes jRadioButton	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getRdo_btn_setA() {
		if (rdo_btn_setA == null) {
			rdo_btn_setA = new JRadioButton();
			rdo_btn_setA.setBounds(new java.awt.Rectangle(10,70,21,21));
			
			
		}
		return rdo_btn_setA;
	}

	/**
	 * This method initializes jRadioButton1	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getRdo_btn_setB() {
		if (rdo_btn_setB == null) {
			rdo_btn_setB = new JRadioButton();
			rdo_btn_setB.setBounds(new java.awt.Rectangle(10,92,23,21));
		
		}
		return rdo_btn_setB;
	}

	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextField() {
		if (jTextField == null) {
			jTextField = new JTextField();
			jTextField.setBounds(new java.awt.Rectangle(8,337,526,26));
		}
		return jTextField;
	}

	/**
	 * This method initializes jRadioButton2	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getRdo_btn_protein() {
		if (rdo_btn_protein == null) {
			rdo_btn_protein = new JRadioButton();
			rdo_btn_protein.setBounds(new java.awt.Rectangle(10,186,21,24));
			
			
		}
		return rdo_btn_protein;
	}

	/**
	 * This method initializes jRadioButton3	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getRdo_btn_nucleo() {
		if (rdo_btn_nucleo == null) {
			rdo_btn_nucleo = new JRadioButton();
			rdo_btn_nucleo.setBounds(new java.awt.Rectangle(10,210,29,26));
			
		}
		return rdo_btn_nucleo;
	}

	public static JRadioButton getSelection(ButtonGroup group) {
        for (Enumeration e=group.getElements(); e.hasMoreElements(); ) {
            JRadioButton b = (JRadioButton)e.nextElement();
            if (b.getModel() == group.getSelection()) {
                return b;
            }
        }
        return null;
    }
	
	/**
	 * Dem geneigten Leser sei es zur Uebung hinterlassen diesen static,public
	 * synchronzied pseudoobj code zu "richten"
	 * @param des1
	 * @param des2
	 * @return
	 */
	public static synchronized BlastDialogReturn showDialog(String des1, String des2) {
		BlastDialog self = new BlastDialog();
		JDialog ich = self.getJDialog();
		self.label_desc1.setText(des1);
		self.label_desc2.setText(des2);
		ich.setVisible(true);
		BlastDialogReturn ret = new BlastDialogReturn();
		
		ret.canceled=self.canceled;
		if (getSelection(self.group1)==BlastDialog.rdo_btn_setA) {
			ret.choosenQuerySet=0;
		}
		if (getSelection(self.group1)==self.rdo_btn_setB) {
			ret.choosenQuerySet=1;
		}
		
		if (getSelection(self.group2)==self.rdo_btn_protein) {
			ret.sequenceType=BlastDialogReturn.PROTEIN;
		}
		if (getSelection(self.group2)==self.rdo_btn_nucleo) {
			ret.sequenceType=BlastDialogReturn.NUCLEOTID;
		}
		String userParam =self.jTextField.getText().trim(); 
		if (userParam.length()>=1) {
			ret.paramStr=userParam;
		} else ret.paramStr=null;
	
		return ret;
	}

	
	/**
	 * @param args
	 */
	public static void main(String[] args) {

        Logger logger = Logger.getLogger(BlastDialog.class);
        BlastDialogReturn ret = showDialog("descr1","desc2");
		logger.debug(ret);
	}

}
