/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universit�t M�nchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: BlastVsDbDialog.java,v 1.7 2006/04/12 12:24:57 hager Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.engine.seqproperties.mapper;

import gr.zeus.ui.JMessage;

import java.io.File;
import java.util.Enumeration;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

import org.apache.log4j.Logger;

import prompt.ui.SaveUI;

/**
 * ziemlicher bullshit, aber eclipse's visual editor ist ja auch nur 10 Jahre
 * Delphi hinterher.
 * 
 * @author tschmidt
 * @author schrader
 * 
 */
public class BlastVsDbDialog {
	Logger logger = Logger.getLogger(this.getClass());

	private JDialog jDialog = null; // @jve:decl-index=0:visual-constraint="29,32"

	private JPanel jContentPane = null;

	private JButton btn_ok = null;

	private JButton btn_cancel = null;

	private JLabel jLabel1 = null;

	private JTextField jTextField = null;

	private JLabel jLabel2 = null;

	public JRadioButton rdo_btn_protein = null;

	public JRadioButton rdo_btn_nucleo = null;

	private JLabel jLabel3 = null;

	private JLabel jLabel4 = null;

	private JLabel jLabel5 = null;

	private JLabel jLabel6 = null;

	/**
	 * This method initializes jDialog
	 * 
	 * @return javax.swing.JDialog
	 */
	private JDialog getJDialog() {
		if (jDialog == null) {
			jDialog = new JDialog();
			jDialog.setSize(new java.awt.Dimension(613, 410));
			jDialog.setModal(true);
			jDialog.setTitle("Blast Settings");
			jDialog.setContentPane(getJContentPane());
		}

		group2 = new ButtonGroup();
		rdo_btn_protein.setSelected(true);
		rdo_btn_nucleo.setSelected(false);
		group2.add(rdo_btn_protein);
		group2.add(rdo_btn_nucleo);

		return jDialog;
	}

	public ButtonGroup group2;

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {

		if (jContentPane == null) {

			jLabel8 = new JLabel();
			jLabel8.setBounds(new java.awt.Rectangle(8, 78, 39, 21));
			jLabel8.setText("File:");
			jLabel7 = new JLabel();
			jLabel7.setBounds(new java.awt.Rectangle(8, 45, 266, 32));
			jLabel7
					.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN,
							12));
			jLabel7.setText("Specify the location of the database file.");
			jLabel = new JLabel();
			jLabel.setBounds(new java.awt.Rectangle(8, 23, 94, 22));
			jLabel.setText("Database File:");
			jLabel6 = new JLabel();
			jLabel6.setBounds(new java.awt.Rectangle(8, 119, 117, 20));
			jLabel6.setText("Sequence Type:");
			jLabel5 = new JLabel();
			jLabel5.setBounds(new java.awt.Rectangle(6, 227, 147, 22));
			jLabel5.setText("BLAST Parameter:");
			jLabel4 = new JLabel();
			jLabel4.setBounds(new java.awt.Rectangle(45, 187, 251, 22));
			jLabel4.setText("nucleotid sequences");
			jLabel3 = new JLabel();
			jLabel3.setBounds(new java.awt.Rectangle(45, 161, 251, 22));
			jLabel3.setText("amino acid sequences");
			jLabel2 = new JLabel();
			jLabel2.setBounds(new java.awt.Rectangle(8, 132, 565, 32));
			jLabel2
					.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN,
							12));
			jLabel2
					.setText("<html>Specify the kind of sequences. Note: All sequences in both sets must be of the same kind.</html>");
			jLabel1 = new JLabel();
			jLabel1.setBounds(new java.awt.Rectangle(6, 243, 584, 44));
			jLabel1
					.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN,
							12));
			jLabel1
					.setText("<html>Enter a custom parameter string for your blastall search. <b>Leave it empty to use default values!</b><br>The parameters -p, -i, -m, -b must not be set, they are included automatically.</html> ");

			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(getJButton(), null);
			jContentPane.add(getJButton1(), null);

			jContentPane.add(jLabel1, null);
			jContentPane.add(getJTextField(), null);
			jContentPane.add(jLabel2, null);
			jContentPane.add(getRdo_btn_protein(), null);
			jContentPane.add(getRdo_btn_nucleo(), null);
			jContentPane.add(jLabel3, null);
			jContentPane.add(jLabel4, null);
			jContentPane.add(jLabel5, null);
			jContentPane.add(jLabel6, null);
			jContentPane.add(jLabel, null);
			jContentPane.add(getJTextField1(), null);
			jContentPane.add(getJButton2(), null);
			jContentPane.add(jLabel7, null);
			jContentPane.add(jLabel8, null);
		}
		return jContentPane;
	}

	boolean canceled = true;

	private JLabel jLabel = null;

	private JTextField jTextField1 = null;

	private JButton jButton = null;

	private JLabel jLabel7 = null;

	private JLabel jLabel8 = null;

	/**
	 * This method initializes jButton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton() {
		if (btn_ok == null) {
			btn_ok = new JButton();
			btn_ok.setBounds(new java.awt.Rectangle(506, 342, 75, 30));
			btn_ok.setText("OK");
			// btn_ok.setSelected(true);
			btn_ok.setName("btn_ok");
			btn_ok.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					logger.debug("ok()");
					if (jTextField1.getText().trim().equalsIgnoreCase("")) {
						JMessage.showMessageDialog(null,
								"No Database File selected",
								JOptionPane.ERROR_MESSAGE,
								JOptionPane.DEFAULT_OPTION);
					} else {
						try {
							File tmp = new File(jTextField1.getText().trim());
							if (tmp.exists()) {
								canceled = false;
								jDialog.dispose();
							} else {
								JMessage.showMessageDialog(null, "File "
										+ jTextField1.getText().trim()
										+ " does not exist.",
										JOptionPane.ERROR_MESSAGE,
										JOptionPane.DEFAULT_OPTION);
							}
						} catch (Exception ex) {
							JMessage.showMessageDialog(null, "File "
									+ jTextField1.getText().trim()
									+ " does not exist.",
									JOptionPane.ERROR_MESSAGE,
									JOptionPane.DEFAULT_OPTION, ex);
						}
					}
				}
			});
		}
		return btn_ok;
	}

	/**
	 * This method initializes jButton1
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton1() {
		if (btn_cancel == null) {
			btn_cancel = new JButton();
			btn_cancel.setBounds(new java.awt.Rectangle(406, 342, 87, 30));
			btn_cancel.setText("CANCEL");
			btn_cancel.setToolTipText("");
			btn_cancel.setName("btn_cancel");
			btn_cancel.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					logger.debug("cancel()"); // TODO Auto-generated Event
												// stub actionPerformed()
					jDialog.dispose();
				}
			});
		}
		return btn_cancel;
	}

	/**
	 * This method initializes jTextField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField() {
		if (jTextField == null) {
			jTextField = new JTextField();
			jTextField.setBounds(new java.awt.Rectangle(6, 294, 526, 26));
		}
		return jTextField;
	}

	/**
	 * This method initializes jRadioButton2
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getRdo_btn_protein() {
		if (rdo_btn_protein == null) {
			rdo_btn_protein = new JRadioButton();
			rdo_btn_protein.setBounds(new java.awt.Rectangle(10, 159, 21, 24));

		}
		return rdo_btn_protein;
	}

	/**
	 * This method initializes jRadioButton3
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getRdo_btn_nucleo() {
		if (rdo_btn_nucleo == null) {
			rdo_btn_nucleo = new JRadioButton();
			rdo_btn_nucleo.setBounds(new java.awt.Rectangle(10, 183, 29, 26));

		}
		return rdo_btn_nucleo;
	}

	public static JRadioButton getSelection(ButtonGroup group) {
		for (Enumeration e = group.getElements(); e.hasMoreElements();) {
			JRadioButton b = (JRadioButton) e.nextElement();
			if (b.getModel() == group.getSelection()) {
				return b;
			}
		}
		return null;
	}

	/**
	 * Dem geneigten Leser sei es zur Uebung hinterlassen diesen static,public
	 * synchronzied pseudoobj code zu "richten"
	 * 
	 * @param des1
	 * 
	 * @return
	 */
	public static synchronized FastaVsDbDialogReturn showDialog(String des1) {
		BlastVsDbDialog self = new BlastVsDbDialog();
		JDialog ich = self.getJDialog();

		ich.setVisible(true);
		FastaVsDbDialogReturn ret = new FastaVsDbDialogReturn();

		ret.canceled = self.canceled;

		ret.dbFile = new File(self.jTextField1.getText().trim());
		if (getSelection(self.group2) == self.rdo_btn_protein) {
			ret.sequenceType = FastaVsDbDialogReturn.PROTEIN;
		}
		if (getSelection(self.group2) == self.rdo_btn_nucleo) {
			ret.sequenceType = FastaVsDbDialogReturn.NUCLEOTID;
		}
		String userParam = self.jTextField.getText().trim();
		if (userParam.length() >= 1) {
			ret.paramStr = userParam;
		} else
			ret.paramStr = null;

		return ret;
	}

	/**
	 * This method initializes jTextField1
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField1() {
		if (jTextField1 == null) {
			jTextField1 = new JTextField();
			jTextField1.setBounds(new java.awt.Rectangle(53, 78, 288, 21));
		}
		return jTextField1;
	}

	/**
	 * This method initializes jButton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton2() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setBounds(new java.awt.Rectangle(345, 78, 96, 21));
			jButton.setText("Browse...");
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					String filename = SaveUI.load("Database File", "*.*");
					jTextField1.setText(filename);
				}
			});
		}
		return jButton;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Logger logger = Logger.getLogger(BlastVsDbDialog.class);
		FastaVsDbDialogReturn ret = showDialog("descr1");
		logger.debug(ret);
	}

}
