/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: SwissProtEngineResult.java,v 1.5 2006/03/19 11:58:11 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.engine.swissProt;

/**
 * @author gormanns
 * 
 */

import java.io.IOException;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Hashtable;

import org.apache.log4j.Logger;

import prompt.engine.EngineResults;

public class SwissProtEngineResult extends EngineResults implements
		Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;



	private Hashtable resultTable;



	private ArrayList descriptions;

	public SwissProtEngineResult(String property) {
		super.setDescription(description);
	}

	public SwissProtEngineResult(String property, Hashtable result) {

		this.description = property;
		this.resultTable = result;
	}

	public SwissProtEngineResult(String property, String resultString) {

		this.desc1 = property;
		this.description = property;
		this.result = resultString;
	}

	public SwissProtEngineResult(String property, String resultString,
			Hashtable resultTable) {

		this.desc1 = property;
		this.description = property;
		this.result = resultString;
		this.resultTable = resultTable;
	}



	public SwissProtEngineResult(String property, String resultString,
			Hashtable resultTable,  ArrayList descriptions) {

		this.desc1 = (String)descriptions.get(0);
		this.desc2 = (String)descriptions.get(1);
		this.description = property;
		this.result = resultString;
		this.resultTable = resultTable;
		
		this.descriptions = descriptions;
	}

	public SwissProtEngineResult(String property, String resultString,
			Hashtable resultTable, ArrayList descriptions,
			String resultType) {

		this.desc1 = (String)descriptions.get(0);
		this.desc2 = (String)descriptions.get(1);
		this.description = property;
		this.result = resultString;
		this.resultTable = resultTable;
		
		this.descriptions = descriptions;
		this.resultType = resultType;
		setResultDescription("<html><u><b><font color=red><font size=4>absolute frequency:</font></b></u><br>Specifies the <b>number of occurrences</b> of a property entry in its SwissProt object.<br><br><u><b><font color=red><font size=4>relative frequency:</font></b></u><br>Specifies the <b>number of occurrences</b> of a property entry in its SwissProt object, <b>relative</b> to the total amount of entries of this property.<br><br><u><b><font color=red><font size=4>absolute ratio:</font></b></u><br>The ratio is calculated by dividing the <b>smaller</b> absolute frequency value of a property entry by the <b>greater</b> absolute frequency  value.The result is a value between 0 and 1 wich describes the similarity of the occurrence of this property entry between the two SwissProt objects.The <b>closer to 1</b> the value is, the property entry, focused on, appears in both SwissProt objects relatively <b>similar</b>.The amount of appearences of this property entry is equal in both SwissProt objects, if the value equals 1.The <b>closer to 0</b> the value is, the property entry, focused on, appears in both SwissProt objects relatively <b>dissimilar</b>.If the absolute frequency value of one property entry of an SwissProt object equals 0, the absolute ratio is set to <b>-Infinity</b> to express maximum frequency difference.<br><br><u><b><font color=red><font size=4>relative ratio:</font></b></u><br>The calculation equals that of the absolute ratio but instead of absolute frequency values, relative frequencies are used.<br><br><u><b><font color=red><font size=4>log ratio:</font></b></u><br>The log ratio value is calculated by logarithmizing the relative ratios between SwissProt objects.</html>");
	}

	public void setResultTable(Hashtable result) {

		this.resultTable = result;
	}

	public Hashtable getResultTable() {

		return this.resultTable;
	}


	public ArrayList getDescriptions() {
		return descriptions;
	}

	public void setDescriptions(ArrayList descriptions) {
		this.descriptions = descriptions;
	}

	public String getDescAll() {
		return desc1;

	}
	public void loadDataFromFile(String filename)throws IOException{
        Logger logger = Logger.getLogger(this.getClass());
		logger.debug("TESTER"); //WAS SOLL DAS DENN?? Philip + Florian bitte fertig machen. THORSTEN
	};
	public static void main(String[] args) {

		// SwissProtEngineResult test = new SwissProtEngineResult();

	}

}
