/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: IBlimps.java,v 1.2 2006/01/05 02:19:12 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.input;

import java.util.HashMap;

/**
 * @author Schmidt Thorsten <a href="mailto:t.schmidt@wzw.tum.de>t.schmidt@wzw.tum.de</a>
 *
 */
public interface IBlimps {

	/**
	 * Im Fall von PEDANT2: ist die Tabelle blimps ueberhaupt da 
	 * und ist was drin, dann true
	 * @return boolean
	 */
	public boolean isBlimpsAvailable();
	
	/**
	 * Returns for each protein all blimps-IDs
	 * than the choosen threshold<br>
	 * <b>If a sub-type character is added to the blimps id than this
	 * subtype is cut off., e.g. IPB001342A will result in IPB001342</b><br>
	 * <b>Example:</b><br>
	 * prot_data.code -> IPB001342;IPB001342; IPB001341..<br>
	 * @param eValThreshold
	 * @return HashMap key=prot_data.code, value=Strichpunkt getrennte Liste von
	 * Ids
	 */
	public HashMap getBlimpsIds(String eValThreshold);
	
	/**
	 * comment for the blimps Identifiers, if a alphabetic character is at the
	 * last position of the blimps id this character is not considered i.e.
	 * the ids with these sub types are not distinguised
	 * @return
	 */
	public HashMap getBlimpsDesc();
	
}
