/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: IGenericProperty.java,v 1.2 2006/01/05 02:19:12 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.input;

import java.util.HashMap;

/**
 * @author Schmidt Thorsten <a href="mailto:t.schmidt@wzw.tum.de>t.schmidt@wzw.tum.de</a>
 *
 */
public interface IGenericProperty {

	public final int NUMERIC = 0;
	public final int SYMBOLIC = 1;
    public final int SETDEF = 2;
    public final int ANY_NUM_OR_SYM = 10;
    public final int ANY = 11;
	
	public final int YETUNKOWN = -1;
	
	/**
	 * @return NUMERIC or SYMBOLIC
	 * or YETUNKOWN if the property was not initialised with data
	 */
	public int getType();
	
	/**
	 * Returns the value of the 'id' attribute of the property node
	 * @return String
	 */
	public String getId();
	
	
	/**
	 * Returns the attribute values of all input-nodes of the property<br>
     * If one protein has multiple feature annotations e.g. more than one funcat than
     * these features are summed up in the value with strichpunkt getrennt.
	 * keys = prot_id (as String)
	 * value = value (as String)
	 */
	public  HashMap getValues();
	
}
