/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: IInput.java,v 1.4 2006/04/12 12:33:16 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.input;

import java.awt.Component;

/**
 * Basic class for all INPUT objects
 * 
 * @author Schmidt Thorsten <a href="mailto:t.schmidt@wzw.tum.de>t.schmidt@wzw.tum.de</a>
 *
 */
public interface IInput extends IJobTemplate {
  final long serialVersionUID = -6849794470754667700L;
	public final String NOTAVAILABLE = "Feature(s) not available";


	/**
	 * For the GUI to work around SUN's JAVA bugs
	 * @param win Component
	 */
	public void setParentWindow(Component win);
	
	
	/**
	 * @return String
	 * @uml.property name="Description"
	 */
	public abstract String getDescription();

	/**
	 * Input set description, should be unique within a
	 * workspace/experiment.
	 * @uml.property name="Description"
	 */
	public abstract void setDescription(String string);

	/**
	 * Returns class specific information e.g. 
	 * data source, number of properties...
	 * @return String
	 */
	public abstract String getMetaData();
	


}
