/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: ISequenceSet.java,v 1.2 2006/01/05 02:19:12 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.input;

import java.io.File;
import java.io.IOException;

import prompt.engine.IEngineResults;



/**
 * @author Schmidt Thorsten <a href="mailto:t.schmidt@wzw.tum.de>t.schmidt@wzw.tum.de</a>
 *
 */
public interface ISequenceSet extends ISeqProperties,IInput{

  final long serialVersionUID = -6849794470754667700L;
	/**
	 * Plain file with every line one sequence.
	 * @param file
	 */
	public void init(File file) throws IOException;
	
	/**
	 * processes Strings/EngineResults die 
	 * - nur aus Sequencen bestehen, d.h. je Zeile eine Seq. oder
	 * - die folgende Formate haben
	 * SeqName TAB  Sequence   oder
	 * SeqName TAB SeqAnnotation TAB Sequence
	 * @param str
	 */
	public void init(String str);
	
	/**
	 * @param result
	 */
	public void init(IEngineResults result);
		

	public boolean addSequence(String seq, String name, String annotation);
	
}
