package prompt.input;

/**
 * 
 * <b>Interface Simap Sequence Lookup</b>
 * Queries the Simap Webservice and returns the
 * Simap Sequence Ids for a single sequence or a list
 * of sequences
 * 
 * @author tschmidt, rarnold
 *
 */
public interface ISimapSeqLookup {

	
	
	/**
	 * @param sequence (aa sequence, nur amino acids, kein header)
	 * @return Integer[] array with 2 elements
	 * 1) simap Id, 0 falls kein hit gefunden wird.
	 * 2) sequence ident. in prozent mal 1000 (
	 * 0.975  = 9750
	 */
	public Integer[] getSimapId(String sequence);
	
	
	/**
	 * Reihenfolge der Rueckgabewerte entspricht der Queryreihenfolge<br>
	 * sequence-id=0 falls kein hit gefunden wird.
	 * @param sequences
	 * @return jede Zeile ein Hit
	 * @see #getSimapId(String)
	 */
	public Integer[][] getSimapIds(String[] sequences);
	
	
}
