/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: ITango.java,v 1.2 2006/01/05 02:19:13 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.input;

import java.io.IOException;
import java.util.List;

/**
 * 
 * <a href="http://binfo.bio.wzw.tum.de/about/mailto?mailname=t.schmidt">contact</a><br>
 * <a href="http://binfo.bio.wzw.tum.de/groups/frishman/">group web site</a><br>
 * @author tschmidt
 */

public interface ITango {
    
	/**
	 * Returns the number of Beta-aggregation Stretches of a a single sequence
	 * for a sequence List. The used method is TANGO is used http://tango.embl.de/
	 * 
	 * @return LinkedList
	 * @throws IOException
	 * @throws NumberFormatException
	 */
	public List getBetaAggregationStretches() throws NumberFormatException,
			IOException;

}
