/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universit�t M�nchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: Description.java,v 1.5 2006/04/06 11:56:09 hager Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.input.classes.swissProt.internals;

import java.io.Serializable;
import java.util.Hashtable;

public class Description implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private Hashtable descriptionPaths;

	public Description() {
				this.descriptionPaths = new Hashtable();
	}

	/**
	 * 
	 * @param groupNumber
	 * @param description
	 */
	public void newDEEntry(String description) {
		String[] descParts = description.split("\\.");
		String name;	
		for (int i = 0; i < descParts.length; i++) {
			if (i == 0) {
				addPathGroup(descParts[i]);
			} else {
				name = "";
				for (int j = 0; j <= i; j++) {
					if (j == 0) {
						name += descParts[j];
					} else {
						name += "." + descParts[j];
					}
				}
				if (!descParts[i].equals("-")) {
					addPathGroup(name);
				}
			}
		}
	}

	/**
	 * 
	 * @return
	 */
	public Hashtable getDESummary() {
		return this.descriptionPaths;
	}

	/**
	 * 
	 * @param group
	 * @param id
	 */
	public void addPathGroup(String id) {
		int counter = 0;
		if (!this.descriptionPaths.containsKey(id)) {
			counter++;
			this.descriptionPaths.put(id, new Integer(counter));
		} else {
			counter = ((Integer) this.descriptionPaths.get(id)).intValue();
			this.descriptionPaths.put(id, new Integer(counter + 1));
		}
	}

	public static void main(String[] args) {
		Description test = new Description();
		test.newDEEntry("3.15.6.3");
		test.newDEEntry("3.4.6.2");
		test.newDEEntry("3.15.7.1");
		test.newDEEntry("4.15.7.3");
		test.newDEEntry("5.-.-.-");

	}
}
