/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: FeatureTable.java,v 1.3 2006/03/19 11:58:03 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.input.classes.swissProt.internals;

import java.io.Serializable;
import java.util.Hashtable;

public class FeatureTable implements Serializable{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private Hashtable ft;

	public FeatureTable(){
		ft = new Hashtable();
	}

	public Hashtable getFTSummary(){
		return ft;
	}

	public void newFTEntry(String[] features){
		int frequency;
        for (int i=0; i< features.length; i++){
			String feature = features[i];
			if (ft.containsKey(feature)){
				frequency = ((Integer) ft.get(feature)).intValue();
				ft.put(feature, new Integer(frequency+1));
			}
			else{
				ft.put(feature, new Integer(1));
			}
		}
	}
}
