/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: Keywords.java,v 1.3 2006/03/19 11:58:03 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.input.classes.swissProt.internals;

import java.io.Serializable;
import java.util.Hashtable;

public class Keywords implements Serializable{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private Hashtable kw;


	public Keywords(){
		kw = new Hashtable();
	}

	public Hashtable getKWSummary(){
		return kw;
	}

	public void newKWEntry(String[] keywords){
		int frequency;
        for (int i=0; i< keywords.length; i++){
			String keyword = keywords[i];
			if (kw.containsKey(keyword)){
				frequency = ((Integer) kw.get(keyword)).intValue();
				kw.put(keyword, new Integer(frequency+1));
			}
			else{
				kw.put(keyword, new Integer(1));
			}
		}
	}
}
