/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: OrganismClassification.java,v 1.3 2006/03/19 11:58:03 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.input.classes.swissProt.internals;

import java.io.Serializable;
import java.util.Hashtable;

public class OrganismClassification implements Serializable{

/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	//	private Graph tree;
	private boolean createGraph = false;
    Hashtable propertyInput;

	public OrganismClassification() {
	//	tree = new Graph();
		propertyInput = new Hashtable();
	}

	public Hashtable getOCSummary() {
		return propertyInput;
	}

    public void addPathGroup(String id){
        int counter = 0;
        if(!this.propertyInput.containsKey(id)){
            counter++;
            this.propertyInput.put(id, new Integer(counter));
        }
        else{
            counter = ((Integer)this.propertyInput.get(id)).intValue();
            this.propertyInput.put(id, new Integer(counter+1));
        }
    }
    
    
    /*This method adds an new Organism Classification entry from one SwissProtdataset to the hashtable!*/
    public void newOCEntry(String description){
        String[] descParts = description.split("\\.");
        String name;
             for(int i = 0; i < descParts.length; i++){
            if(i==0){
                addPathGroup(descParts[i]);
            }               
            else {
                name = "";
                for(int j = 0; j <= i; j++){
                    if (j==0){
                        name += descParts[j];
                    }
                    else{
                        name += "." + descParts[j];
                    }
                }
                addPathGroup(name);
            }
        }       
    }
//	public void newOCEntry(String input) {
//      
////        if(!createGraph){
////            String local="";
////            String[] inputArray = input.split("\\.");
////            for(int i=0;i<inputArray.length;i++){
////                if(i<inputArray.length-1){
////                local.concat(inputArray[i]+".");}else{
////                    
////                    local.concat(inputArray[i]);
////                }
////                if()
////                
////            }
////            
////        }else{
////		String[] inputArray = input.split("\\.");
////		for (int i = 0; i < inputArray.length; i++) {
////
////			if (i != 0 && i != inputArray.length - 1) {
////				tree.addNode(inputArray[i], inputArray[i + 1], inputArray[i-1]);
////
////			} else {
////				if (i == 0) {
////					tree.addNode(inputArray[i], inputArray[i + 1], "root");
////				} else {
////
////					tree.addNode(inputArray[i], "", inputArray[i - 1]);
////				}
////			}
////
////		}}
//	}
	
	public static void main (String[] args)
	{
	//	OrganismClassification  test = new OrganismClassification();
	//	test.newOCEntry(1, "Human.Home.Sapi");
		
	}
}
