/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: Reference.java,v 1.3 2006/03/19 11:58:03 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.input.classes.swissProt.internals;

import java.io.Serializable;
import java.util.Hashtable;

public class Reference implements Serializable{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private Hashtable medline;
	private Hashtable pubMed;

	public Reference(){
		medline = new Hashtable();
		pubMed = new Hashtable();
	}

	public Hashtable getMedlineSummary(){
		return medline;
	}

	public Hashtable getPubMedSummary(){
		return pubMed;
	}
	
	public Hashtable[] getReferenceSummary(){
		Hashtable[] references = new Hashtable[]{medline, pubMed};
		return references;
	}

	public void newReferenceEntry( String[] references){
		
		
		String medlineID = references[0];		
		if (medlineID != null){
			newMedlineEntry( medlineID);
		}
		
		String pubMedID = references[1];
		if (pubMedID != null){
			newPubMedEntry( pubMedID);
		}
	}
	
	public void newMedlineEntry( String id){
		
		if (medline.containsKey(id)){
			int frequency = ((Integer) medline.get(id)).intValue();
			frequency++;
			medline.put(id, new Integer(frequency));
		}else{
			int frequency =1;
			medline.put(id, new Integer(frequency));
		}
		
	}

	public void newPubMedEntry( String id){
		
		if (pubMed.containsKey(id)){
			int frequency = ((Integer) pubMed.get(id)).intValue();
			frequency++;
			pubMed.put(id, new Integer(frequency));
		}
		else{
			int frequency = 1;
			
			pubMed.put(id, new Integer(frequency));
		}	
	}
}
