/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universit�t M�nchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: SwissProtFileReader.java,v 1.8 2006/04/06 11:56:09 hager Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.input.classes.swissProt.internals;

import java.io.File;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;

import org.apache.log4j.Logger;

import prompt.input.classes.swissProt.SwissProt;
import prompt.input.swissProt.ISwissProtFileReader;

public class SwissProtFileReader implements Serializable {

    /**
     * 
     */
    private static final long serialVersionUID = 1L;

    ArrayList<File> inputData;

    boolean isXML;

    ISwissProtFileReader parsed;

    public void setIsXML(boolean isXML) {
        this.isXML = isXML;
    }

    public boolean getIsXML() {
        return this.isXML;
    }

    /**
     * @param isXML
     *            can be FORMAT_FLAT, FORMAT_XML
     * @param isMultiple
     *            boolean
     */
    public SwissProtFileReader(int format) {
        Logger logger = Logger.getLogger(this.getClass().getName());
        if (format == SwissProt.FORMAT_XML)
            isXML = true;
        else
            isXML = false;
    }

    public void setInput(ArrayList<File> input) {
        this.inputData = input;
    }

    public ArrayList getInput() {
        return inputData;
    }

    public ISwissProtFileReader readFile() throws Exception {
        Logger logger = Logger.getLogger(this.getClass().getName());
        if (isXML)
            parsed = new SwissProtXMLFileReader();
        else
            parsed = new SwissProtFlatFileReader();

        parsed.parseSwissProtFileArray(inputData);
        return parsed;
    }
    
    public Iterator getIterator() {
    	return parsed.getIterator();
    }

}
