/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: IFilterIdAble.java,v 1.3 2006/04/10 13:24:16 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.input.filter;

/**
 * Haben alle Input-Objekte die einen Filter als Moeglichkeit anbieten bzw.<br>
 * all Input-Interfaces/Classes which supply support to a filter must implement this interface IFilterAble
 * @author schmidt
 */
public interface IFilterIdAble {

	/**
	 * @return the filter in use or null if none
	 * @uml.property name="filter"
	 * @uml.associationEnd multiplicity="(0 1)"
	 */
	public IFilterId getFilterId();

	/**
	 * Sets a filter
	 * @param filter IFilterId
	 * @uml.property name="filter"
	 */
	public void setFilterId(IFilterId filter);

}
