/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: IPedantFilter.java,v 1.2 2006/01/05 02:19:21 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.input.filter;

/**
 * @author schmidt
 *
 */
public interface IPedantFilter extends IFilterId {

	/**
	 * Adds all prot_data_ids returned by your SQL Query to the Filter<br>
	 * Your query must return only one column which contains the unique prot-data-ids<br>
	 * @param sql: e.g. select prot_data_id from .... where ....
	 */
	public void filterAddFromSqlQuery(String dbname, String sql);
	
	
	/**
	 * Has to be called to delete a temporary view table
	 */
	public void delViewTable();
}
