/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: ISwissProt.java,v 1.4 2006/03/19 11:58:11 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.input.swissProt;

import prompt.input.IInput;
import prompt.input.ISeqProperties;
import prompt.input.classes.swissProt.internals.Description;
import prompt.input.classes.swissProt.internals.Domain;
import prompt.input.classes.swissProt.internals.FeatureTable;
import prompt.input.classes.swissProt.internals.Keywords;
import prompt.input.classes.swissProt.internals.Organelle;
import prompt.input.classes.swissProt.internals.OrganismClassification;
import prompt.input.classes.swissProt.internals.OrganismSpecies;
import prompt.input.classes.swissProt.internals.Reference;

public interface ISwissProt extends IInput, ISeqProperties{


	public Description getDE();

	public FeatureTable getFT();

	public Keywords getKW() ;

	public OrganismClassification getOC();

	public Organelle getOG() ;

	public OrganismSpecies getOS();

	public Reference getRX() ;
	
	public Domain getDOM() ;

	
	public void run() throws Exception;

}
