/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universit�t M�nchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: ISwissProtFileReader.java,v 1.5 2006/04/06 11:56:09 hager Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.input.swissProt;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.jdom.JDOMException;

import prompt.input.classes.swissProt.internals.Description;
import prompt.input.classes.swissProt.internals.Domain;
import prompt.input.classes.swissProt.internals.FeatureTable;
import prompt.input.classes.swissProt.internals.Keywords;
import prompt.input.classes.swissProt.internals.Organelle;
import prompt.input.classes.swissProt.internals.OrganismClassification;
import prompt.input.classes.swissProt.internals.OrganismSpecies;
import prompt.input.classes.swissProt.internals.Reference;

public interface ISwissProtFileReader {
    
    public void parseSwissProtFileArray(ArrayList<File> proteinGroupArray) throws FileNotFoundException, JDOMException, Exception;
    public Description getDE();
    public FeatureTable getFT();
    public Keywords getKW();
    public OrganismClassification getOC();
    public Organelle getOG();
    public OrganismSpecies getOS();
    public Reference getRX();
    public Domain getDOM();  
    public ArrayList getAC();
    
    public Iterator getIterator();
    
    public List getSequences();
    public List getSequencesNames();
    public List getAnnotation();

}
