/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: PP.java,v 1.4 2006/03/20 00:59:13 hager Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.statistic;

import prompt.engine.IEngineResults;
import prompt.statistic.pdef.Checkbox;
import prompt.statistic.pdef.Textarea;
import tschmidt.rinterface.RParser;


public class PP extends Test {
	public final String testName = "PP";
	 private final static long serialVersionUID = -6849794470754667700L;
	/**
		 *
		 */
	public PP() {
		super();
		super.testName = testName;
		// TODO Auto-generated constructor stub
	}

	/**
	 * @param data
	 * @throws Exception
	 */
	public void init(IEngineResults data) throws Exception {
		super.init(data);
		super.testName = testName;
		// TODO Auto-generated constructor stub
	}

	/**
	 * @param data
	 * @param testParams
	 * @param prefix
	 * @throws Exception
	 */
	public void init(IEngineResults data, String testParams, String prefix) throws Exception {
		super.init(data, testParams, prefix);
		super.testName = testName;
		// TODO Auto-generated constructor stub
	}

	/**
	 * @param data
	 * @param string
	 * @throws Exception
	 */
	public void init(IEngineResults data, String string) throws Exception {
		super.init(data, string);
		super.testName = testName;
		}
	/* (non-Javadoc)
	 * @see prompt.statistic.Test#setParameter()
	 */
	protected void setParameter() {
		paramDescription =
			new Object[] {
				"Phillips-Perron Test",
				"Computes the Phillips-Perron test for the\n"
					+ "null hypothesis that 'x' has a unit root against\n"
					+ "a stationary alternative.",
				"The general regression equation which incorporates a constant and"
					+ "a linear trend is used and the corrected t-statistic for a first"
					+ "order autoregressive coefficient equals one is computed.  To"
					+ "estimate 'sigma^2' the Newey-West estimator is used.  If 'lshort'"
					+ "is 'TRUE', then the truncation lag parameter is set to"
					+ "'trunc(4*(n/100)^0.25)', otherwise 'trunc(12*(n/100)^0.25)' is"
					+ "used.  The p-values are interpolated from Table 4.2, page 103 of"
					+ "Banerjee _et al._ (1993).\n"
					+ "Missing values are not handled.",
				new Textarea(
					"Dataselect",
					"dataselect",
					DATASELECTHELP,
					""),
				new Checkbox(
					"Lshort",
					"lshort",
					"a logical indicating whether the short or long version\n"
						+ "of the truncation lag parameter is used.",
					false)};

	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	public int hashCode() {
		// TODO Auto-generated method stub
		return 0;
	}

	/* (non-Javadoc)
	 * @see de.tum.binfo.jdrm.JobTemplate#run()
	 */
	public void run() throws Exception {
		RParser p = new RParser();
		String statement =
			"testm = as.matrix(data)\n" + "ret = PP.test(" + testParams + ")\n";
		performTest(statement);
		output = p.parseROutput(getProcessingMessages());

	}

}
