/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: MannWhitneyApp.java,v 1.2 2006/01/05 02:19:20 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.statistic.ext;

import prompt.engine.IEngineResults;

/**
 *	calls: engine class for calculating distribution of aa's (aaDistribution)
 *	&& 20x mann-whithney test  
 *  
 *
 */
public class MannWhitneyApp extends Compare2Distributions {

  private static final long serialVersionUID = -6849794470754667700L;
	/**
	 * @param res
	 * @throws Exception
	 */
	public void init(IEngineResults res) throws Exception {
		super.init(res);
	}
	
	public void run() throws Exception {
		this.setTestname("prompt.statistic.MannWhitney");
		super.run();
	}

}
