/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: ShapiroTestApp.java,v 1.3 2006/03/19 11:58:12 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.statistic.ext;

import java.util.Vector;

import prompt.engine.EngineResults;
import prompt.statistic.ShapiroTest;
import prompt.statistic.Test;




public class ShapiroTestApp extends Test {
  private final static long serialVersionUID = -6849794470754667700L;
    private final String[] aminoAlphabet =
    {
            "A","R","N","D","C","Q","E","G","H",
            "I","L","K","M","F","P","S","T","W","Y","V"
    };
	/*private final String[] aminoAlphabet3 =
		{
			"TYR",
			"VAL",
			"THR",
			"GLY",
			"MET",
			"PHE",
			"GLU",
			"ARG",
			"ALA",
			"PRO",
			"GLN",
			"ASP",
			"ASN",
			"LYS",
			"CYS",
			"SER",
			"TRP",
			"LEU",
			"ILE",
			"HIS" };
	
	*/
	
	
	protected Vector pValuesA = new Vector();
	protected Vector pValuesB = new Vector();
	/**
	 * @param data
	 * @throws Exception
	 */
	public void init(EngineResults data) throws Exception {
		super.init(data);
	
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		StringBuffer strBuff = new StringBuffer();
		strBuff.append("SET\tAA\tP_VALUE\n");
		for (int i = 0; i < pValuesA.size(); i++) {
			strBuff.append(
				"setA\t"
					+ aminoAlphabet[i]
					+ "\t"
					+ pValuesA.elementAt(i)
					+ "\n");
		}
		for (int j = 0; j < pValuesB.size(); j++) {
			strBuff.append(
				"setB\t"
					+ aminoAlphabet[j]
					+ "\t"
					+ pValuesB.elementAt(j)
					+ "\n");
		}
		return strBuff.toString();
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	public int hashCode() {
		
		return 0;
	}

	/* (non-Javadoc)
	 * @see de.tum.binfo.jdrm.JobTemplate#run()
	 */
	public void run() throws Exception {
		for (int i = 0; i < 20; i++) {
			ShapiroTest stA =
				new ShapiroTest();
			stA.init(
					data,
					"data[data$AA==\""
						+ aminoAlphabet[i]
						+ "\" & data$DATASET==\"setA\",3]\n");
			stA.run();

			float fA =
				(new Float((String) stA.getTestResults().get("$p.value")))
					.floatValue();
			pValuesA.add(new Float(fA));

			ShapiroTest stB =
				new ShapiroTest();
			stB.init(
					data,
					"data[data$AA==\""
						+ aminoAlphabet[i]
						+ "\" & data$DATASET==\"setB\",3]\n");
			stB.run();

			float fB =
				(new Float((String) stB.getTestResults().get("$p.value")))
					.floatValue();
			pValuesB.add(new Float(fB));
		}
	}

	protected void setParameter() {
	}
}
