/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: Checkbox.java,v 1.2 2006/01/05 02:19:20 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.statistic.pdef;

/**
 * Creates a <code>JCheckBox</code> for the <code>TestCustomizer</code>
 * 
 */
public class Checkbox {
  private final static long serialVersionUID = -6849794470754667700L;
	/**
	 * The text of the checkbox
	 */
	public String label;
	
	/**
	 * The R name of the argument
	 */
	public String rArgument;
	
	/**
	 * The help text, which is shown in the help frame of the
	 * <code>TestCustomizer</code>
	 */
	public String help;
	
	/**
	 * The default value for the checkbox (here: checked or not)
	 */
	public boolean defaultValue;

	/**
	 * @param label	The text of the checkbox
	 * @param rArgument	The R name of the argument
	 * @param help	The help text, which is shown in the help frame of the <code>TestCustomizer</code>
	 * @param defaultValue	The default value for the checkbox (here: checked or not)
	 */
	public Checkbox(
		String label,
		String rArgument,
		String help,
		boolean defaultValue) {
		this.label = label;
		this.rArgument = rArgument;
		this.help = help;
		this.defaultValue = defaultValue;
	}

}
