/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: Textfield.java,v 1.2 2006/01/05 02:19:20 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.statistic.pdef;

/**
 * Creates a <code>JTextField</code> for the <code>TestCustomizer</code>
 * 
 */
public class Textfield {
  private final static long serialVersionUID = -6849794470754667700L;
	/**
	 * The text of the textfield
	 */
	public String label;

	/**
	 * The R name of the argument
	 */
	public String rArgument;

	/**
	 * The help text, which is shown in the help frame of the
	 * <code>TestCustomizer</code>
	 */
	public String help;
	
	/**
	 * The initial content of the textfield
	 */
	public String defaultValue;

	/**
	 * @param label	The text of the textfield
	 * @param rArgument	The R name of the argument
	 * @param help	The help text, which is shown in the help frame of the <code>TestCustomizer</code>
	 * @param defaultValue	The initial content of the textfield
	 */
	public Textfield(String label, String rArgument, String help, String defaultValue)
	{
		this.label=label;
		this.rArgument = rArgument;
		this.help=help;
		this.defaultValue=defaultValue;
	}

}
