package prompt.ui;

import gr.zeus.ui.JMessage;

import java.awt.BorderLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.io.BufferedWriter;
import java.io.FileWriter;

import javax.swing.JEditorPane;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTable;

import org.apache.log4j.Logger;

public class DataTableNew extends JFrame {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private JPanel jContentPane = null;

	private JMenuBar jJMenuBar = null;

	private JMenu jMenu = null;

	private JMenuItem jMenuItem1 = null;

	private JMenuItem jMenuItem2 = null;

	private JMenuItem jMenuItem3 = null;

	private JMenuItem jMenuItemClose = null;

	private JMenuItem jMenuItemCopy = null;

	private JMenuItem jMenuItemSelectAll = null;

	private JMenu jMenu1 = null;

//	private JMenu jMenu2 = null;

	private JSplitPane jSplitPane = null;

	private JScrollPane jScrollPane = null;

	private JEditorPane jEditorPane = null;

	private JScrollPane jScrollPane1 = null;

	private JTable jTable = null;

	private String description;

//	private String imageDirectory = null;

//	private File file;

	private String metaData;

	private ExcelAdapter myAd = null;

	/**
	 * This is the default constructor
	 */
	public DataTableNew(String desc, JTable table) {
		super();
		this.description = desc;
		this.jTable = table;

		MyListModel lm = new MyListModel();
		lm.initializeRowHeaders(this.jTable.getRowCount());
		this.jTable.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		// this.jTable.setColumnSelectionAllowed(true);
		// this.jTable.setRowSelectionAllowed(true);

		this.jTable.setCellSelectionEnabled(true);
		myAd = new ExcelAdapter(jTable);
		JList rowHeader = new JList(lm);
		rowHeader.setFixedCellWidth(50);
		rowHeader.setFixedCellHeight(this.jTable.getRowHeight());
		rowHeader.setCellRenderer(new RowHeaderRenderer(this.jTable));
		jScrollPane1 = getJScrollPane1();
		jScrollPane1.setRowHeaderView(rowHeader);
		getContentPane().add(jScrollPane1, BorderLayout.CENTER);
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(474, 325);
		this.setJMenuBar(getJJMenuBar());
		this.setContentPane(getJContentPane());
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {

			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints.gridy = 0;
			gridBagConstraints.weightx = 1.0;
			gridBagConstraints.weighty = 1.0;
			gridBagConstraints.gridx = 0;
			jContentPane = new JPanel();
			jContentPane.setLayout(new GridBagLayout());
			jContentPane.add(getJSplitPane(), gridBagConstraints);

		}
		return jContentPane;
	}

	/**
	 * This method initializes jJMenuBar
	 * 
	 * @return javax.swing.JMenuBar
	 */
	private JMenuBar getJJMenuBar() {
		if (jJMenuBar == null) {
			jJMenuBar = new JMenuBar();
			jJMenuBar.add(getJMenu());
			jJMenuBar.add(getJMenu1());
		}
		return jJMenuBar;
	}

	/**
	 * This method initializes jMenu
	 * 
	 * @return javax.swing.JMenu
	 */
	private JMenu getJMenu() {
		if (jMenu == null) {
			jMenu = new JMenu("File");
			jMenu.add(getJMenuItem1());
			jMenu.add(getJMenuItem2());
			jMenu.add(getJMenuItem3());
			jMenu.addSeparator();
			jMenu.add(getJMenuItemClose());
		}
		return jMenu;
	}

	/**
	 * This method initializes jMenuItem
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItem1() {
		if (jMenuItem1 == null) {
			jMenuItem1 = new JMenuItem("SaveAsExcel...");
			jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					saveAsDocumentExcel();
				}
			});
		}
		return jMenuItem1;
	}

	/**
	 * This method initializes jMenuItem
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItem2() {
		if (jMenuItem2 == null) {
			jMenuItem2 = new JMenuItem("SaveAsCSV....");
			jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					saveAsDocumentCSV();
				}
			});
		}
		return jMenuItem2;
	}

	/**
	 * This method initializes jMenuItem
	 * 
	 * @return javax.swing.JMenuItem
	 */
	private JMenuItem getJMenuItem3() {
		if (jMenuItem3 == null) {
			jMenuItem3 = new JMenuItem("SaveAsEngineResults...");
			jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					saveAsDocumentEngineResults();
				}
			});
		}
		return jMenuItem3;
	}

	private JMenuItem getJMenuItemClose() {
		if (jMenuItemClose == null) {
			jMenuItemClose = new JMenuItem("Close");
			jMenuItemClose.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					dispose();
				}
			});
		}
		return jMenuItemClose;
	}

	/**
	 * This method initializes jMenu1
	 * 
	 * @return javax.swing.JMenu
	 */
	private JMenu getJMenu1() {
		if (jMenu1 == null) {
			jMenu1 = new JMenu("Edit");
			jMenu1.add(getJMenuCopy());
			jMenu1.add(getJMenuSelectAll());
		}
		return jMenu1;
	}

	private JMenuItem getJMenuCopy() {
		if (jMenuItemCopy == null) {
			jMenuItemCopy = new JMenuItem("Copy");
			jMenuItemCopy.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					copy();
				}
			});
		}
		return jMenuItemCopy;
	}

	private JMenuItem getJMenuSelectAll() {
		if (jMenuItemSelectAll == null) {
			jMenuItemSelectAll = new JMenuItem("Select All");
			jMenuItemSelectAll.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					selectAll();
				}
			});
		}
		return jMenuItemSelectAll;
	}

	public void selectAll() {
		this.jTable.selectAll();
	}

	public void copy() {
		ActionEvent event = new ActionEvent(this, ActionEvent.CTRL_MASK, "Copy");
		myAd.actionPerformed(event);
	}

	/**
	 * This method initializes jSplitPane
	 * 
	 * @return javax.swing.JSplitPane
	 */
	private JSplitPane getJSplitPane() {
		if (jSplitPane == null) {
			jSplitPane = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
			jSplitPane.setContinuousLayout(true);
			jSplitPane.setDividerSize(5);
			jSplitPane.setTopComponent(getJScrollPane());
			jSplitPane.setBottomComponent(getJScrollPane1());
			jSplitPane.setDividerLocation(70);
		}
		return jSplitPane;
	}

	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getJEditorPane());

		}
		return jScrollPane;
	}

	/**
	 * This method initializes jEditorPane
	 * 
	 * @return javax.swing.JEditorPane
	 */
	private JEditorPane getJEditorPane() {
		if (jEditorPane == null) {
			jEditorPane = new JEditorPane("text/html", description);
			jEditorPane.setEditable(false);
			jEditorPane.setCaretPosition(0);
		}
		return jEditorPane;
	}

	/**
	 * This method initializes jScrollPane1
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane1() {
		if (jScrollPane1 == null) {
			jScrollPane1 = new JScrollPane();
			jScrollPane1.setViewportView(getJTable());
		}
		return jScrollPane1;
	}

	/**
	 * This method initializes jTable
	 * 
	 * @return javax.swing.JTable
	 */
	private JTable getJTable() {
		if (jTable == null) {
			jTable = new JTable();
		}
		jTable.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		return jTable;
	}

	/**
	 * Save Results as a CSV-File
	 */
	private void saveAsDocumentCSV() {
		// logger.debug("SaveAsCSV");
		Logger logger = Logger.getLogger(this.getClass().getName());

		if (jTable.isEditing()) {
			jTable.getCellEditor().stopCellEditing();
		}
		String filename = SaveUI.save("Export Results as CSV file", ".csv");
		if (filename != null) {
			try {
				logger.debug("write data file to '" + filename + "'");

				BufferedWriter out = new BufferedWriter(new FileWriter(filename));
//				String[] metaDataCSV = metaData.split("\\s");
//				for (int i = 0; i < metaDataCSV.length; i++) {
//					out.write(metaDataCSV[i]);
//					out.write(";");
//				}
				out.write(this.metaData);
				// write columns
				for (int i = 0; i < jTable.getColumnCount(); i++) {

					String colName = jTable.getColumnModel().getColumn(i).getHeaderValue().toString();
					if (!colName.trim().startsWith("\"")) {
						out.write("\"");
					}
					out.write(colName);
					if (!colName.trim().endsWith("\"")) {
						out.write("\"");
					}
					out.write(";");
				}
				out.write("\n");
				// write data
				for (int j = 0; j < jTable.getRowCount(); j++) {
					for (int i = 0; i < jTable.getColumnCount(); i++) {
						String value = (String) jTable.getValueAt(j, i);
						if (value!=null) {
						
						if (!value.trim().startsWith("\"")) {
							out.write("\"");
						}
						
						out.write(value);
						if (!value.trim().endsWith("\"")) {
							out.write("\"");
						}
						}
						else out.write("");
						out.write(";");
						
					}
					out.write("\n");
				}
				out.flush();
				out.close();
			} catch (Exception e) {
				String errmsg = "Error writing results to file '" + filename + "'";
				logger.error(errmsg, e);
				JMessage.showMessageDialog(this, errmsg, JOptionPane.ERROR_MESSAGE, JOptionPane.DEFAULT_OPTION,e);
			}
		}

	}

	/**
	 * Save Document as Excel
	 */
	private void saveAsDocumentExcel() {
		Logger logger = Logger.getLogger(this.getClass().getName());

		if (jTable.isEditing()) {
			jTable.getCellEditor().stopCellEditing();
		}

		String filename = SaveUI.save("Save results as Excel file", ".xls");
		if (filename != null) {
			try {
				logger.debug("write data file to '" + filename + "'");
				SaveAsExcelThread thread = new SaveAsExcelThread(metaData, filename, jTable);
				thread.run();
			} catch (Exception e) {
				String errmsg = "Error writing results to file '" + filename + "'";
				logger.error(errmsg, e);
				JMessage.showMessageDialog(this, errmsg, JOptionPane.ERROR_MESSAGE, JOptionPane.DEFAULT_OPTION);
			}
		}
	}

	/**
	 * 
	 */
	private void saveAsDocumentEngineResults() {
		Logger logger = Logger.getLogger(this.getClass().getName());
		if (jTable.isEditing()) {
			jTable.getCellEditor().stopCellEditing();
		}

		String filename = SaveUI.save("Save results as Text file", ".txt");
		if (filename != null) {
			try {
				logger.debug("write data file to '" + filename + "'");
				// this.visual.saveDataToFile(filename);

				BufferedWriter out = new BufferedWriter(new FileWriter(filename));

				out.write(this.metaData);

				// write Columns
				if (jTable.isEditing()) {
					jTable.getCellEditor().stopCellEditing();
				}
				for (int i = 0; i < jTable.getColumnCount(); i++) {
					out.write(jTable.getColumnModel().getColumn(i).getHeaderValue().toString());
					out.write("\t");
				}
				out.write("\n");

				// write Data
				for (int j = 0; j < jTable.getRowCount(); j++) {
					for (int i = 0; i < jTable.getColumnCount(); i++) {
						if (!((String) jTable.getValueAt(j, i) == null)) {
							out.write((String) jTable.getValueAt(j, i));
							out.write("\t");
						}
					}
					out.write("\n");
				}
				out.flush();
				out.close();
			} catch (Exception e) {
				String errmsg = "Error writing results to file '" + filename + "'";
				logger.error(errmsg, e);
				JMessage.showMessageDialog(this, errmsg, JOptionPane.ERROR_MESSAGE, JOptionPane.DEFAULT_OPTION);
			}
		}

	}

	/**
	 * @param metaData
	 */
	public void setMetaData(String metaData) {
		this.metaData = metaData;
	}

} // @jve:decl-index=0:visual-constraint="10,10"
