/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: DialogFactory.java,v 1.4 2006/03/02 21:13:45 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.ui;

import gr.zeus.ui.JMessage;

import java.io.File;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

import org.apache.log4j.Logger;


public abstract class DialogFactory extends JFrame {
    
    public static Object[] options = { "Yes", "No" };
    public static  Object[] threeOptions = { "Yes", "No", "Cancel" };
	
	public static String showInputDescriptionDialog(String filename) {
        Logger logger = Logger.getLogger(DialogFactory.class);
        String s=null;
        while ((s==null) || (s.trim().length()==0)) {
        s =
			(String) JOptionPane.showInputDialog(
				null,
				"Please enter a description for \"" + filename + "\"",
                filename);
        if (s==null) {
            logger.debug("canceled input dialog");
            return null;
        }
        if (s.trim().length()==0) {
            String errmsg = "Your object needs at least a description";
            JMessage.showMessageDialog(null, errmsg, JOptionPane.ERROR_MESSAGE, JOptionPane.DEFAULT_OPTION);
         }
        }
		return s.trim();
	}
    

    
    
    public static String showInputDescriptionDialogFile(String filename) {
        String file = filename;
        //versuchen nur das letzte zu finden
        int sepIndex = filename.lastIndexOf(File.separator);
        int len = filename.length();
        if ((sepIndex>-1) && ((len-sepIndex)>0)) {
            file = filename.substring(sepIndex + 1,len);
        }
        return showInputDescriptionDialog(file);
    }
    

	public static String showResultDescriptionDialog() {
		String s =
			(String) JOptionPane.showInputDialog(
				null,
				"Please enter a description for the result");
		return s;
	}

	/*public static String showDbChooseDialog() {
		String s =
			(String) JOptionPane.showInputDialog(
				null,
				"Please enter database name",
				"abundance_thorsten");
		return s;
	} 
	*/
	
	public static int showFileExistDialog(String filename) {
	   return JOptionPane.showOptionDialog(null,
                "File " + filename + " already exists!\nOverwrite?", "Overwrite?",
                JOptionPane.YES_NO_CANCEL_OPTION,
                JOptionPane.QUESTION_MESSAGE, null, threeOptions,
                threeOptions[1]);
	}
	
	public static int showAddExtension(String extension) {
	    return JOptionPane.showOptionDialog(null,
                "Add extension " + extension + " to filename?", "Extension",
                JOptionPane.YES_NO_CANCEL_OPTION,
                JOptionPane.QUESTION_MESSAGE, null, threeOptions,
                threeOptions[1]);
	}
	
    public static String chooseDlg(String qst, String title, String[] possibilities, String def) {
        String s =
    		(String) JOptionPane.showInputDialog(
    			null,
    			title,
    			qst,
    			JOptionPane.QUESTION_MESSAGE,
    			null,
    			possibilities, def
    			);
    		return s;
        }
}
