package prompt.ui;

import java.io.File;
import java.io.IOException;

import javax.swing.JOptionPane;
import javax.swing.JTable;

import jxl.Workbook;
import jxl.write.Label;
import jxl.write.Number;
import jxl.write.WritableCellFormat;
import jxl.write.WritableFont;
import jxl.write.WritableSheet;
import jxl.write.WritableWorkbook;
import jxl.write.WriteException;
import jxl.write.biff.RowsExceededException;

import org.apache.commons.lang.math.NumberUtils;
import org.apache.log4j.Logger;

public class SaveAsExcelThread extends Thread{
	
	private String metaData;
	private String filename;
	private JTable jTable;
	
	public SaveAsExcelThread(String metaData,String filename,JTable jTable){
		this.metaData = metaData;
		this.filename = filename;
		this.jTable = jTable;
	}
	public void run(){
		try {
			// Get and Split MetaData
			String[] metaArray = this.metaData.split("#");
			// Create Excel Workbook
			WritableWorkbook workbook = Workbook.createWorkbook(new File(filename));
			// Create ExcelSheet
			WritableSheet sheet = workbook.createSheet("Sheet a", 0);

			// Adding MetaData to ExcelFile
			Label label;
			for (int i = 0; i < metaArray.length; i++) {
				label = new Label(0, i, metaArray[i]);
				sheet.addCell(label);
			}
			//Adding Column Names
			WritableFont ARIAL10font = new WritableFont(WritableFont.ARIAL, 10, WritableFont.BOLD, true);
			WritableCellFormat ARIAL10format = new WritableCellFormat (ARIAL10font); 
									
			for (int i = 0; i < jTable.getColumnCount(); i++) {
				label = new Label(i, metaArray.length, jTable
						.getColumnModel().getColumn(i)
						.getHeaderValue().toString(),ARIAL10format);
				sheet.addCell(label);
			}
			
			//Adding Values to ExcelFile
			Number number;
			
			for (int i = 0; i < jTable.getColumnCount(); i++) {
				for (int j = 0; j < jTable.getRowCount(); j++) {
					if (!((String) jTable.getValueAt(j, i) == null)) {
						if (NumberUtils.isNumber((String) jTable.getValueAt(j,i))) 
						{
							number = new Number(i,j+ metaArray.length+1,
							  Double.parseDouble((String) jTable.getValueAt(j,i)));
							try {
								sheet.addCell(number);
							} catch (Exception e) {
								JOptionPane.showMessageDialog(
								 null,"Number of Rows of an ExcelWorksheet exceeded!\nTry to save as EngineResultsFile.\nSaving Failed!");
								break;
							}
						} else {
							
							label = new Label(i, j+ metaArray.length+1,
									(String) jTable.getValueAt(j,i));
							try {
								sheet.addCell(label);
							} catch (Exception e) {
								JOptionPane.showMessageDialog(
								 null,"Number of Rows of an ExcelWorksheet exceeded!\nTry to save as EngineResultsFile.\nSaving Failed!");
								break;
							}
						}
					}
				}
			}

			workbook.write();
			workbook.close();
			Logger logger = Logger.getLogger(this.getClass().getName());
			logger.debug("File written: '" + filename + "'");

		} catch (IOException e) {
			e.printStackTrace();
		} catch (RowsExceededException e) {
			e.printStackTrace();
		} catch (WriteException e) {
			e.printStackTrace();
		}
	}
}
