/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: GeneMergeDialog.java,v 1.3 2006/03/19 11:58:11 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.ui.geneMergeDialog;


import gr.zeus.ui.JMessage;

import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.io.File;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import prompt.ui.SaveUI;


public class GeneMergeDialog extends JDialog {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	private JLabel labelGeneAssFile = null;
	private JLabel labelDescriptionjLabel1 = null;
	private JTextField textGeneAssFile = null;
	private JTextField textDescFile = null;
	private JLabel labelPopulationFile = null;
	private JLabel labelStudyFile = null;
	private JTextField textPopfile = null;
	private JTextField textStudyFile = null;
	private JButton buttoncancel = null;
	private JButton buttonGeneAss = null;
	private JButton buttonDescFile = null;
	private JButton buttonPopFile = null;
	private JButton buttonStudyFile = null;
	private JButton buttonOK = null;
	private JLabel labelHeader = null;
	private GeneMergeProperties properties = null;
	private boolean[] ready ={false,false,false,false};
	/**
	 * This is the default constructor
	 */
	public GeneMergeDialog(Frame owner) {
		super(owner,true);
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(479, 237);
		this.setContentPane(getJContentPane());
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			GridBagConstraints gridBagConstraints111 = new GridBagConstraints();
			gridBagConstraints111.gridx = 1;
			gridBagConstraints111.insets = new java.awt.Insets(10,0,0,0);
			gridBagConstraints111.gridy = 0;
			labelHeader = new JLabel();
			labelHeader.setText("GeneMerge");
			labelHeader.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 18));
			GridBagConstraints gridBagConstraints10 = new GridBagConstraints();
			gridBagConstraints10.gridx = 2;
			gridBagConstraints10.ipady = 0;
			gridBagConstraints10.ipadx = 8;
			gridBagConstraints10.insets = new java.awt.Insets(13,16,11,23);
			gridBagConstraints10.gridy = 13;
			GridBagConstraints gridBagConstraints9 = new GridBagConstraints();
			gridBagConstraints9.gridx = 2;
			gridBagConstraints9.insets = new java.awt.Insets(2,0,5,0);
			gridBagConstraints9.gridy = 12;
			GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
			gridBagConstraints8.gridx = 2;
			gridBagConstraints8.insets = new java.awt.Insets(2,0,5,0);
			gridBagConstraints8.gridy = 4;
			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			gridBagConstraints7.gridx = 2;
			gridBagConstraints7.insets = new java.awt.Insets(2,0,5,0);
			gridBagConstraints7.gridy = 2;
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.gridx = 2;
			gridBagConstraints6.ipadx = 0;
			gridBagConstraints6.ipady = 0;
			gridBagConstraints6.gridheight = 1;
			gridBagConstraints6.insets = new java.awt.Insets(2,0,5,0);
			gridBagConstraints6.anchor = java.awt.GridBagConstraints.SOUTH;
			gridBagConstraints6.weighty = 0.0;
			gridBagConstraints6.weightx = 0.0;
			gridBagConstraints6.gridy = 1;
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.gridx = 1;
			gridBagConstraints5.gridwidth = 1;
			gridBagConstraints5.gridheight = 1;
			gridBagConstraints5.anchor = java.awt.GridBagConstraints.EAST;
			gridBagConstraints5.insets = new java.awt.Insets(13,16,11,3);
			gridBagConstraints5.ipadx = 3;
			gridBagConstraints5.ipady = 0;
			gridBagConstraints5.fill = java.awt.GridBagConstraints.NONE;
			gridBagConstraints5.gridy = 13;
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints4.gridy = 12;
			gridBagConstraints4.weightx = 1.0;
			gridBagConstraints4.gridx = 1;
			GridBagConstraints gridBagConstraints31 = new GridBagConstraints();
			gridBagConstraints31.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints31.gridy = 4;
			gridBagConstraints31.weightx = 1.0;
			gridBagConstraints31.gridx = 1;
			GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
			gridBagConstraints21.gridx = 0;
			gridBagConstraints21.anchor = java.awt.GridBagConstraints.EAST;
			gridBagConstraints21.gridy = 12;
			labelStudyFile = new JLabel();
			labelStudyFile.setText("Study file: ");
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.gridx = 0;
			gridBagConstraints11.anchor = java.awt.GridBagConstraints.EAST;
			gridBagConstraints11.gridy = 4;
			labelPopulationFile = new JLabel();
			labelPopulationFile.setText("Population file: ");
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints3.gridy = 2;
			gridBagConstraints3.weightx = 1.0;
			gridBagConstraints3.gridx = 1;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints2.gridy = 1;
			gridBagConstraints2.weightx = 1.0;
			gridBagConstraints2.gridwidth = 1;
			gridBagConstraints2.insets = new java.awt.Insets(5,0,5,0);
			gridBagConstraints2.anchor = java.awt.GridBagConstraints.SOUTH;
			gridBagConstraints2.ipadx = 0;
			gridBagConstraints2.gridx = 1;
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridx = 0;
			gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
			gridBagConstraints1.gridy = 2;
			labelDescriptionjLabel1 = new JLabel();
			labelDescriptionjLabel1.setText("Description file: ");
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.anchor = java.awt.GridBagConstraints.SOUTH;
			gridBagConstraints.insets = new java.awt.Insets(8,0,5,0);
			gridBagConstraints.gridy = 1;
			labelGeneAssFile = new JLabel();
			labelGeneAssFile.setText("Gene-association file: ");
			jContentPane = new JPanel();
			jContentPane.setLayout(new GridBagLayout());
			jContentPane.add(labelGeneAssFile, gridBagConstraints);
			jContentPane.add(labelDescriptionjLabel1, gridBagConstraints1);
			jContentPane.add(labelPopulationFile, gridBagConstraints11);
			jContentPane.add(labelStudyFile, gridBagConstraints21);
			jContentPane.add(getJTextField(), gridBagConstraints2);
			jContentPane.add(getJTextField1(), gridBagConstraints3);
			jContentPane.add(getTextPopfile(), gridBagConstraints31);
			jContentPane.add(getTextStudyFile(), gridBagConstraints4);
			jContentPane.add(getButtoncancel(), gridBagConstraints5);
			jContentPane.add(getButtonGeneAss(), gridBagConstraints6);
			jContentPane.add(getButtonDescFile(), gridBagConstraints7);
			jContentPane.add(getButtonPopFile(), gridBagConstraints8);
			jContentPane.add(getButtonStudyFile(), gridBagConstraints9);
			jContentPane.add(getButtonOK(), gridBagConstraints10);
			jContentPane.add(labelHeader, gridBagConstraints111);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextField() {
		if (textGeneAssFile == null) {
			textGeneAssFile = new JTextField();
		}
		return textGeneAssFile;
	}

	/**
	 * This method initializes jTextField1	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextField1() {
		if (textDescFile == null) {
			textDescFile = new JTextField();
		}
		return textDescFile;
	}

	/**
	 * This method initializes textPopfile	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getTextPopfile() {
		if (textPopfile == null) {
			textPopfile = new JTextField();
		}
		return textPopfile;
	}

	/**
	 * This method initializes textStudyFile	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getTextStudyFile() {
		if (textStudyFile == null) {
			textStudyFile = new JTextField();
		}
		return textStudyFile;
	}

	/**
	 * This method initializes buttoncancel	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getButtoncancel() {
		if (buttoncancel == null) {
			buttoncancel = new JButton();
			buttoncancel.setText("CANCEL");
			buttoncancel.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					dispose();
                    properties=null;
				}
			});
		}
		return buttoncancel;
	}

	/**
	 * This method initializes buttonGeneAss	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getButtonGeneAss() {
		if (buttonGeneAss == null) {
			buttonGeneAss = new JButton();
			buttonGeneAss.setText("Browse...");
			buttonGeneAss.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					String filename = SaveUI.load("GeneAssociation","txt");
					textGeneAssFile.setText(filename);
				}
			});
		}
		return buttonGeneAss;
	}

	/**
	 * This method initializes buttonDescFile	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getButtonDescFile() {
		if (buttonDescFile == null) {
			buttonDescFile = new JButton();
			buttonDescFile.setText("Browse...");
			buttonDescFile.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					String filename = SaveUI.load("Description","txt");
					textDescFile.setText(filename);
				}
			});
		}
		return buttonDescFile;
	}

	/**
	 * This method initializes buttonPopFile	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getButtonPopFile() {
		if (buttonPopFile == null) {
			buttonPopFile = new JButton();
			buttonPopFile.setText("Browse...");
			buttonPopFile.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					String filename = SaveUI.load("PopulationFile","txt");
					textPopfile.setText(filename);
				}
			});
		}
		return buttonPopFile;
	}

	/**
	 * This method initializes buttonStudyFile	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getButtonStudyFile() {
		if (buttonStudyFile == null) {
			buttonStudyFile = new JButton();
			buttonStudyFile.setText("Browse...");
			buttonStudyFile.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					String filename = SaveUI.load("Study File","txt");
					textStudyFile.setText(filename);
				}
			});
		}
		return buttonStudyFile;
	}

	/**
	 * This method initializes buttonOK	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getButtonOK() {
		if (buttonOK == null) {
			buttonOK = new JButton();
			buttonOK.setText("    OK     ");
			buttonOK.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					
					createGeneMargeProperties();
										
					if(ready[0]&&ready[1]&&ready[2]&&ready[3]){
						dispose();
					}else{
						String whatsWrong="";
						
						if(!ready[0]){
							whatsWrong = whatsWrong + "- Gene-association file\n";
						}
						if(!ready[1]){
							whatsWrong = whatsWrong + "- Population file\n";
							
						}
						if(!ready[2]){
							whatsWrong = whatsWrong + "- Study file\n";
						}
						if(!ready[3]){
							whatsWrong = whatsWrong + "- Description file\n";
						}

						JMessage.showMessageDialog(null,
								"Check your Input.\n One or more files are not right specified:\n"+whatsWrong,
								JOptionPane.ERROR_MESSAGE,
								JOptionPane.DEFAULT_OPTION);
					}
				}
			});
		}
		return buttonOK;
	}
	
	public void createGeneMargeProperties(){
		
	    ready[0]= false;
	    ready[1]= false;
	    ready[2]= false;
	    ready[3]= false;
	    
		properties = new GeneMergeProperties();
		
		properties.setGeneAssFile(new File(textGeneAssFile.getText().trim()));
		if(properties.getGeneAssFile().exists()){
			ready[0] = true;
		}
		properties.setPopulationFile(new File(textPopfile.getText().trim()));
		if(properties.getPopulationFile().exists()){
			ready[1] = true;
		}
		properties.setStudyFile(new File(textStudyFile.getText().trim()));
		if(properties.getStudyFile().exists()){
			ready[2] = true;
		}
		properties.setDescFile(new File(textDescFile.getText().trim()));
		if(properties.getDescFile().exists()){
			ready[3] = true;
		}
	}
	
	public GeneMergeProperties getValue(){
		return this.properties;
	}
	
	public static GeneMergeProperties showGeneMergeDialog(Frame frame) {
		GeneMergeDialog self = new GeneMergeDialog(frame);
		//self.setAlwaysOnTop(true);
		self.setVisible(true);
		return self.getValue();
	}
}  //  @jve:decl-index=0:visual-constraint="10,10"
