/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: GeneMergeProperties.java,v 1.2 2006/01/05 02:19:09 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.ui.geneMergeDialog;

import java.io.File;

public class GeneMergeProperties {
	private File geneAssFile;
	private File descFile;
	private File populationFile;
	private File studyFile;
	
	public GeneMergeProperties(){
		
	}
	
	/**
	 * Sets the Gene Association File
	 */
	public void setGeneAssFile(File file){
		this.geneAssFile = file;
	}
	
	/**
	 * Sets the Description File
	 */
	public void setDescFile(File file){
		this.descFile = file;
	}
	/**
	 * Sets the Population File
	 */
	public void setPopulationFile(File file){
		this.populationFile = file;
	}
	/**
	 * Sets the Study File
	 */
	public void setStudyFile(File file){
		this.studyFile = file;
	}
	/**
	 * Sets the Gene Association File
	 */
	public File getGeneAssFile(){
		return this.geneAssFile;
	}
	
	/**
	 * Sets the Description File
	 */
	public File getDescFile(){
		return this.descFile;
	}
	/**
	 * Sets the Population File
	 */
	public File getPopulationFile(){
		return this.populationFile;
	}
	/**
	 * Sets the Study File
	 */
	public File getStudyFile(){
		return this.studyFile;
	}
	
	/** 
	 * 1st String: GeneAssociation File
	 * 2nd String: Description File
	 * 3rd String: PopulationFile
	 * 4th String: StudyFile
	 */
	public String toString(){
		String result="";
		result = geneAssFile.getPath()+
		"\n"+descFile.getPath()+
		"\n"+populationFile.getPath()+
		"\n"+studyFile.getPath();
		return result;
	}
	
	
}
