/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: IDDialog.java,v 1.4 2006/04/12 12:33:17 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.ui.idDialog;

import gr.zeus.ui.JMessage;

import java.awt.Dimension;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.io.File;
import java.util.LinkedList;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import prompt.ui.SaveUI;


public class IDDialog extends JDialog {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	private JRadioButton jRadioButtonFile = null;
	private JTextField jTextFieldFile = null;
	private JButton jButtonBrowse = null;
	private JRadioButton jRadioButtonManuell = null;
//	private JLabel jLabelManuell = null;
	private JScrollPane jScrollPane = null;
	private JTextArea jTextArea = null;
	private JCheckBox jCheckBoxInverse = null;
	private JButton jButtonCancel = null;
	private JButton jButtonOk = null;
	private ButtonGroup group = null;
	//private ButtonGroup group1 = null;
	private IdDialogProperties properties = null;
	private boolean readyFile = false;
	private boolean readyList = false;
//	private JRadioButton jRadioButtonPedant = null;
//	private JRadioButton jRadioButtonProtein = null;
	private JPanel jPanelMain = null;
	private JLabel jLabelInvers = null;
	private JLabel jLabelDesc = null;
	private JLabel jLabelFile2 = null;
	private JLabel jLabelFileDesc = null;
	private JPanel jPanelNorth = null;
	private JLabel jLabelProtein = null;
	private JLabel jLabelPedant = null;
	private JLabel labelHeader1 = null;
	private JLabel jLabeltype = null;
	/**
	 * This is the default constructor
	 */
	public IDDialog(Frame owner) {
		super(owner,true);
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(631, 510);
		this.setContentPane(getJContentPane());
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			GridBagConstraints gridBagConstraints22 = new GridBagConstraints();
			gridBagConstraints22.gridx = 2;
			gridBagConstraints22.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints22.insets = new java.awt.Insets(0,5,0,0);
			gridBagConstraints22.gridy = 1;
//			jLabeltype = new JLabel();
//			jLabeltype.setText("Select your ID type: ");
			GridBagConstraints gridBagConstraints201 = new GridBagConstraints();
			gridBagConstraints201.insets = new java.awt.Insets(5,0,5,5);
			gridBagConstraints201.gridy = 11;
			gridBagConstraints201.gridx = 3;
			GridBagConstraints gridBagConstraints191 = new GridBagConstraints();
			gridBagConstraints191.anchor = GridBagConstraints.EAST;
			gridBagConstraints191.gridx = 2;
			gridBagConstraints191.gridy = 11;
			gridBagConstraints191.insets = new java.awt.Insets(5,0,5,5);
			GridBagConstraints gridBagConstraints181 = new GridBagConstraints();
			gridBagConstraints181.gridx = 2;
			gridBagConstraints181.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints181.insets = new java.awt.Insets(5,5,5,5);
			gridBagConstraints181.weightx = 1.0;
			gridBagConstraints181.weighty = 1.0;
			gridBagConstraints181.gridy = 10;
			GridBagConstraints gridBagConstraints171 = new GridBagConstraints();
			gridBagConstraints171.gridx = 2;
			gridBagConstraints171.insets = new java.awt.Insets(6,0,10,0);
			gridBagConstraints171.gridy = 0;
			labelHeader1 = new JLabel();
			labelHeader1.setText("ID Input Dialog");
			labelHeader1.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 18));
			GridBagConstraints gridBagConstraints161 = new GridBagConstraints();
			gridBagConstraints161.gridx = 2;
			gridBagConstraints161.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints161.insets = new java.awt.Insets(5,7,5,0);
			gridBagConstraints161.gridy = 3;
			getGroup();
			jContentPane = new JPanel();
			jContentPane.setLayout(new GridBagLayout());
			jContentPane.add(getJPanelNorth(), gridBagConstraints161);
			jContentPane.add(labelHeader1, gridBagConstraints171);
			jContentPane.add(getJPanelMain(), gridBagConstraints181);
			jContentPane.add(getJButtonCancel(), gridBagConstraints191);
			jContentPane.add(getJButtonOk(), gridBagConstraints201);
		//	jContentPane.add(jLabeltype, gridBagConstraints22);
			
			jRadioButtonFile.setSelected(true);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jRadioButtonFile	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonFile() {
		if (jRadioButtonFile == null) {
			jRadioButtonFile = new JRadioButton();
			
			
			jRadioButtonFile.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					jLabelFileDesc.setEnabled(true);
					jLabelFile2.setEnabled(true);
					jTextFieldFile.setEnabled(true);
					jButtonBrowse.setEnabled(true);
					jScrollPane.setEnabled(false);
					jTextArea.setEnabled(false);
					jLabelDesc.setEnabled(false);
					
				}
			});
			
		}
		return jRadioButtonFile;
	}

	/**
	 * This method initializes jTextFieldFile	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldFile() {
		if (jTextFieldFile == null) {
			jTextFieldFile = new JTextField();
		}
		return jTextFieldFile;
	}

	/**
	 * This method initializes jButtonBrowse	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonBrowse() {
		if (jButtonBrowse == null) {
			jButtonBrowse = new JButton();
			jButtonBrowse.setText("Browse...");
			jButtonBrowse.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					String filename = SaveUI.load("Id-File","txt");
					jTextFieldFile.setText(filename);
				}
			});
		}
		return jButtonBrowse;
	}

	/**
	 * This method initializes jRadioButtonManuell	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonManuell() {
		if (jRadioButtonManuell == null) {
			jRadioButtonManuell = new JRadioButton();
			jRadioButtonManuell.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					jLabelFileDesc.setEnabled(false);
					jLabelFile2.setEnabled(false);
					jTextFieldFile.setEnabled(false);
					jButtonBrowse.setEnabled(false);
					jScrollPane.setEnabled(true);
					jTextArea.setEnabled(true);
					jLabelDesc.setEnabled(true);
					
				}
			});
		}
		return jRadioButtonManuell;
	}

	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getJTextArea());
		}
		return jScrollPane;
	}

	/**
	 * This method initializes jTextArea	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getJTextArea() {
		if (jTextArea == null) {
			jTextArea = new JTextArea();
		}
		return jTextArea;
	}

	/**
	 * This method initializes jCheckBoxInverse	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getJCheckBoxInverse() {
		if (jCheckBoxInverse == null) {
			jCheckBoxInverse = new JCheckBox();
		}
		return jCheckBoxInverse;
	}

	/**
	 * This method initializes jButtonCancel	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonCancel() {
		if (jButtonCancel == null) {
			jButtonCancel = new JButton();
			jButtonCancel.setText("CANCEL");
			jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					dispose();
				}
			});
		}
		return jButtonCancel;
	}

	/**
	 * This method initializes jButtonOk	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonOk() {
		if (jButtonOk == null) {
			jButtonOk = new JButton();
			jButtonOk.setText("    OK    ");
			jButtonOk.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					createProperties();
					if(readyFile||readyList){
						dispose();
					}else{
						if(jRadioButtonFile.isSelected())
						JMessage.showMessageDialog(null,
								"The selected File does not exist.",
								JOptionPane.ERROR_MESSAGE,
								JOptionPane.DEFAULT_OPTION);
						if(jRadioButtonManuell.isSelected())
							JMessage.showMessageDialog(null,
									"You entered no Ids.",
									JOptionPane.ERROR_MESSAGE,
									JOptionPane.DEFAULT_OPTION);	
					}
					
				}
			});
		}
		return jButtonOk;
	}

	private void createProperties(){
		readyList = false;
		readyFile = false;
		
		properties = new IdDialogProperties();
		if(jRadioButtonFile.isSelected()){
			File idFile = new File(jTextFieldFile.getText().trim());
			if(!idFile.exists()){
				readyFile = false;
			}else{
				readyFile = true;
				properties.setIdFile(idFile);
			}
		}
		if(jRadioButtonManuell.isSelected()){
			if(jTextArea.getText().equalsIgnoreCase("")){
				readyList = false;
			}else{
				readyList = true;
			}
			String[] lines = jTextArea.getText().split("\\n");
			LinkedList list = new LinkedList();
			for (int i = 0; i < lines.length; i++) {
				list.add(lines[i]);
			}
			properties.setIdList(list);
		}
		if(jCheckBoxInverse.isSelected()){
			properties.setInverseSelection(true);
		}
		
//		 if(jRadioButtonPedant.isSelected())
//			properties.setType(IdDialogProperties.PEDANT_ID);
//		if(jRadioButtonProtein.isSelected())
//			properties.setType(IdDialogProperties.PROTEIN_CODES);
	}
	
	/**
	 * This method initializes group
	 * 
	 * @return javax.swing.ButtonGroup
	 */
	private ButtonGroup getGroup() {
		if (group == null) {
			group = new ButtonGroup();
			group.add(getJRadioButtonFile());
			group.add(getJRadioButtonManuell());
			
		}
		return group;
	}
	/*
	private ButtonGroup getGroup1() {
		if (group1 == null) {
			group1 = new ButtonGroup();
			group1.add(getJRadioButtonPedant());
			group1.add(getJRadioButtonProtein());
			
		}
		return group;
	}*/
	
	private IdDialogProperties getValue(){
		return this.properties;
	}
	
	public static IdDialogProperties showIDDialog(Frame frame) {
		IDDialog self = new IDDialog(frame);
		self.setSize(680,480);
		self.setVisible(true);
		return self.getValue();
	}


	/*
	
	private JRadioButton getJRadioButtonPedant() {
		if (jRadioButtonPedant == null) {
			jRadioButtonPedant = new JRadioButton();
			jRadioButtonPedant.setSelected(true);
		}
		return jRadioButtonPedant;
	}

	
	private JRadioButton getJRadioButtonProtein() {
		if (jRadioButtonProtein == null) {
			jRadioButtonProtein = new JRadioButton();
		}
		return jRadioButtonProtein;
	}

	*/
	
	/**
	 * This method initializes jPanelMain	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelMain() {
		if (jPanelMain == null) {
			GridBagConstraints gridBagConstraints20 = new GridBagConstraints();
			gridBagConstraints20.gridx = 2;
			gridBagConstraints20.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints20.gridy = 0;
			jLabelFileDesc = new JLabel();
			jLabelFileDesc.setText("Select a file with IDs: ");
			GridBagConstraints gridBagConstraints19 = new GridBagConstraints();
			gridBagConstraints19.gridx = 1;
			gridBagConstraints19.insets = new java.awt.Insets(0,6,0,5);
			gridBagConstraints19.gridy = 1;
			jLabelFile2 = new JLabel();
			jLabelFile2.setText("File: ");
			GridBagConstraints gridBagConstraints18 = new GridBagConstraints();
			gridBagConstraints18.gridx = 2;
			gridBagConstraints18.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints18.gridy = 2;
			jLabelDesc = new JLabel();
			jLabelDesc.setText("Enter your IDs: (each line one ID, no commas or other seperation characters)");
			GridBagConstraints gridBagConstraints17 = new GridBagConstraints();
			gridBagConstraints17.gridx = 2;
			gridBagConstraints17.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints17.gridy = 4;
			jLabelInvers = new JLabel();
			jLabelInvers.setText("Inverse your selection (means all but your given IDs are used)");
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.gridx = 1;
			gridBagConstraints6.gridy = 2;
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.fill = GridBagConstraints.NONE;
			gridBagConstraints3.gridx = 3;
			gridBagConstraints3.gridy = 1;
			gridBagConstraints3.ipadx = 0;
			gridBagConstraints3.ipady = 0;
			gridBagConstraints3.insets = new java.awt.Insets(2,0,2,5);
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints2.gridx = 2;
			gridBagConstraints2.gridy = 1;
			gridBagConstraints2.weightx = 1.0;
			gridBagConstraints2.insets = new Insets(0, 0, 0, 9);
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridx = 1;
			gridBagConstraints1.gridy = 0;
			
			GridBagConstraints gridBagConstraints16 = new GridBagConstraints();
			gridBagConstraints16.fill = GridBagConstraints.BOTH;
			gridBagConstraints16.gridx = 2;
			gridBagConstraints16.gridy = 3;
			gridBagConstraints16.weightx = 2.0;
			gridBagConstraints16.weighty = 2.0;
			gridBagConstraints16.insets = new Insets(6, 5, 18, 9);
			GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
			gridBagConstraints12.gridx = 1;
			gridBagConstraints12.gridy = 4;
			jPanelMain = new JPanel();
			jPanelMain.setLayout(new GridBagLayout());
			jPanelMain.setPreferredSize(new Dimension(575,329));
			jPanelMain.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.SystemColor.activeCaption,1));
			jPanelMain.add(getJCheckBoxInverse(), gridBagConstraints12);
			jPanelMain.add(getJScrollPane(), gridBagConstraints16);
			jPanelMain.add(getJRadioButtonFile(), gridBagConstraints1);
			jPanelMain.add(getJTextFieldFile(), gridBagConstraints2);
			jPanelMain.add(getJButtonBrowse(), gridBagConstraints3);
			jPanelMain.add(getJRadioButtonManuell(), gridBagConstraints6);
			jPanelMain.add(jLabelInvers, gridBagConstraints17);
			jPanelMain.add(jLabelDesc, gridBagConstraints18);
			jPanelMain.add(jLabelFile2, gridBagConstraints19);
			jPanelMain.add(jLabelFileDesc, gridBagConstraints20);
		}
		return jPanelMain;
	}

	/**
	 * This method initializes jPanelNorth	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelNorth() {
		if (jPanelNorth == null) {
			//getGroup1();
			GridBagConstraints gridBagConstraints9 = new GridBagConstraints();
			gridBagConstraints9.gridx = 1;
			gridBagConstraints9.gridy = 2;
			GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
			gridBagConstraints8.gridx = 1;
			gridBagConstraints8.gridy = 1;
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.gridx = 2;
			gridBagConstraints5.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints5.gridy = 1;
//			jLabelPedant = new JLabel();
//			jLabelPedant.setText("PEDANT IDs");
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.gridx = 2;
			gridBagConstraints4.anchor = java.awt.GridBagConstraints.WEST;
			gridBagConstraints4.gridy = 2;
//			jLabelProtein = new JLabel();
//			jLabelProtein.setText("Protein IDs");
			jPanelNorth = new JPanel();
			jPanelNorth.setLayout(new GridBagLayout());
//			jPanelNorth.add(getJRadioButtonPedant(), gridBagConstraints8);
//			jPanelNorth.add(getJRadioButtonProtein(), gridBagConstraints9);
//			jPanelNorth.add(jLabelProtein, gridBagConstraints4);
//			jPanelNorth.add(jLabelPedant, gridBagConstraints5);
			
		}
		return jPanelNorth;
	}
	

}  //  @jve:decl-index=0:visual-constraint="20,10"
