/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: IdDialogProperties.java,v 1.3 2006/03/19 11:58:06 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.ui.idDialog;

import java.io.File;
import java.util.Iterator;
import java.util.LinkedList;

public class IdDialogProperties {
	private File idFile;
	private LinkedList ids;
	private boolean inverseSelection;
	public final static int PEDANT_ID = 1;
	public final static int PROTEIN_CODES = 2;
	private int type;
	
	public IdDialogProperties(){
		
	}
	
	public void setType(int type){
		this.type = type;
	}
	
	public void setIdFile(File file){
		this.idFile = file;
	}
	
	public void setInverseSelection(boolean bool){
		this.inverseSelection = bool;
	}
	
	public void setIdList(LinkedList list){
		this.ids = list;
	}
	
	public File getIdFile(){
		return this.idFile;
	}
	
	public LinkedList getIds(){
		return this.ids;
	}
	
	public boolean getInverseSelection(){
		return this.inverseSelection;
	}
	
	public int getType(){
		if(type==1){
			return PEDANT_ID;
		}else{
			return PROTEIN_CODES;
		}
	}
	
	public String toString(){
		String result = "";
		if(idFile!=null){
			result = result + idFile.getPath()+"\n";
		}else{
			Iterator iter = ids.iterator(); 
			while(iter.hasNext()){
				result = result +iter.next().toString()+"\n";
			}
		}
		result = result + inverseSelection+"\n";
		result = result + type;
		return result;
	}
	
}
