/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: AALetter1To3.java,v 1.3 2006/03/19 11:58:12 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.util;


/**
 * "Global" used System-Properties: <br>
 * <br>
 * splus.shome = absolut path to S-PLUS root installation folder <br>
 * rproject.rexe = absolut path to R-EXECUTABLE FILE installation <br>
 * <br>
 * Default Database connection settings: <br>
 * def.dbDriver e.g. "com.mysql.jdbc.Driver" <br>
 * def.dbUser e.g. "pedant" <br>
 * def.dbPassword <br>
 * def.dbUrl e.g. "jdbc:mysql://tum-mysql2/" <br>
 * 
 * @author Schmidt
 *  
 */
public class AALetter1To3 implements java.io.Serializable {
   

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public static String getLongAminoAcidName(String acid) {
        String retValue = null;
        if (acid.equalsIgnoreCase("A") || acid.equalsIgnoreCase("ALA"))
            retValue = "Alanine";
        if (acid.equalsIgnoreCase("G") || acid.equalsIgnoreCase("GLY"))
            retValue = "Glycine";
        if (acid.equalsIgnoreCase("L") || acid.equalsIgnoreCase("LEU"))
            retValue = "Leucine";
        if (acid.equalsIgnoreCase("M") || acid.equalsIgnoreCase("MET"))
            retValue = "Methionine";
        if (acid.equalsIgnoreCase("F") || acid.equalsIgnoreCase("PHE"))
            retValue = "Phenyalanine";
        if (acid.equalsIgnoreCase("W") || acid.equalsIgnoreCase("TRP"))
            retValue = "Tryptophan";
        if (acid.equalsIgnoreCase("K") || acid.equalsIgnoreCase("LYS"))
            retValue = "Lysine";
        if (acid.equalsIgnoreCase("Q") || acid.equalsIgnoreCase("GLN"))
            retValue = "Glutamine";
        if (acid.equalsIgnoreCase("E") || acid.equalsIgnoreCase("GLU"))
            retValue = "Glutamic Acid";
        if (acid.equalsIgnoreCase("S") || acid.equalsIgnoreCase("SER"))
            retValue = "Serine";
        if (acid.equalsIgnoreCase("P") || acid.equalsIgnoreCase("PRO"))
            retValue = "Proline";
        if (acid.equalsIgnoreCase("V") || acid.equalsIgnoreCase("VAL"))
            retValue = "Valine";
        if (acid.equalsIgnoreCase("I") || acid.equalsIgnoreCase("ILE"))
            retValue = "Isoleucine";
        if (acid.equalsIgnoreCase("C") || acid.equalsIgnoreCase("CYS"))
            retValue = "Cysteine";
        if (acid.equalsIgnoreCase("Y") || acid.equalsIgnoreCase("TYR"))
            retValue = "Tyrosine";
        if (acid.equalsIgnoreCase("H") || acid.equalsIgnoreCase("HIS"))
            retValue = "Histidine";
        if (acid.equalsIgnoreCase("R") || acid.equalsIgnoreCase("ARG"))
            retValue = "Arginine";
        if (acid.equalsIgnoreCase("N") || acid.equalsIgnoreCase("ASN"))
            retValue = "Asparagine";
        if (acid.equalsIgnoreCase("D") || acid.equalsIgnoreCase("ASP"))
            retValue = "Aspartic Acid";
        if (acid.equalsIgnoreCase("T") || acid.equalsIgnoreCase("THR"))
            retValue = "Threonine";
        return retValue;
    }
}
