/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: ListTools.java,v 1.2 2006/01/05 02:19:07 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.util;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import prompt.input.filter.IFilterValue;



/**
 * @author schmidt
 *
 */
public class ListTools {
	
  public static  synchronized void applyValFilterToList(List list, IFilterValue valFilter) {
		List neu = new LinkedList();
		if (valFilter != null) {
			for (Iterator iter = list.iterator(); iter.hasNext();) {
				Object element = (Object) iter.next();
				if (valFilter.pass(element)) {
					neu.add(element);
				}
			}
			list.clear();
			list.addAll(neu);
			neu.clear();
		} else {
			//logger.debug("No value filter supplied.");
		}
	}
}
