/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: Edge.java,v 1.3 2006/03/19 11:58:11 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.util.graph;

import java.io.Serializable;


public class Edge implements IEdge, Serializable {


	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	String identifier;
	String[] nodes = new String[2];
	
	public void setNodes(String[] nodes) {
		this.nodes = nodes;
	}

	
	public String[] getNodes() {
		return nodes;
	}

	
	public void setNode(String node, int nodeNr) {
		nodes[nodeNr]=node;

	}

	
	public String getNode(int nodeNr) {
	
		return nodes[nodeNr];
	}

	
	public void setIdentifier(String id) {
		this.identifier=id;
	}

	
	public String getIdentifier() {
		return identifier;
	}

}
