/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: Graph.java,v 1.3 2006/03/19 11:58:10 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.util.graph;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Hashtable;


public class Graph implements IGraph, Serializable {


	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	String name;

	Hashtable nodes;

	Hashtable edges;

	public Graph() {

		name = "Phylogenetic Tree";
		nodes = new Hashtable();
		edges = new Hashtable();
	}

	public Graph(String name) {

		this.name = name;
		nodes = new Hashtable();
		edges = new Hashtable();

	}

	public void setNodes(Hashtable nodes) {
		this.nodes = (Hashtable) nodes.clone();

	}


	public Hashtable getNodes() {
		return nodes;
	}

	
	public void setEdges(Hashtable edges) {
		this.edges = (Hashtable) edges.clone();
	}


	public Hashtable getEdges() {
		return edges;
	}

	
	public void addNode(String identifier, String successor,
			String predecessor) {
		try {
			Node tmpNode = (Node) nodes.get(identifier);
			tmpNode.increaseCounter();
			nodes.put(identifier, tmpNode);

		} catch (NullPointerException npe) {
			Node node = new Node();
			node.setIdentifier(identifier);
			
			//Edge edge2 = new Edge();
			//edge2.setIdentifier(identifier + "_" + successor);
			//edge2.setNodes(new String[] { identifier, successor });

			ArrayList localEdges = new ArrayList();


			//Edge edge1 = new Edge();
			//edge1.setIdentifier(predecessor + "_" + identifier);
			
			
		//	localEdges.add(edge1.getIdentifier());
			
			//edges.put(edge1.getIdentifier(), edge1);
			
			try {
				Node tmpNode = (Node) nodes.get(predecessor);
				Edge edge2 = new Edge();
				edge2.setIdentifier(predecessor+ "_" +identifier);
                edge2.setNodes(new String[] {predecessor,identifier });
				tmpNode.getEdgesOutgoing().add(edge2);
				localEdges.add(edge2);// checken ob
				// referenzen
				// passen!!!
				edges.put(edge2.getIdentifier(), edge2);
				nodes.put(tmpNode.getIdentifier(), tmpNode);
				node.setEdgesIncoming(localEdges);
				node.increaseCounter();
				
				nodes.put(node.getIdentifier(), node);
			}
			
			catch (NullPointerException e) {

				Node tmpNode = new Node();
				tmpNode.setIdentifier("root");
				Edge edge2 = new Edge();
				edge2.setIdentifier("root"+ "_" +identifier);
				edge2.setNodes(new String[] { "root",identifier });
				ArrayList rootEdges= new ArrayList();
				rootEdges.add(edge2);
				tmpNode.setEdgesOutgoing(rootEdges);
				edges.put(edge2.getIdentifier(), edge2);
				//Edge edge2 = new Edge();
				//edge2.setIdentifier("root"+"_"+successor);
				//tmpNode.getEdges().add(edge2);
				
				// checken ob
				// referenzen
				// passen!!!
				nodes.put(tmpNode.getIdentifier(), tmpNode);
				
				node.setEdgesIncoming(localEdges);
				node.increaseCounter();

				nodes.put(node.getIdentifier(), node);
			}

			
			
//			if(!(successor.equalsIgnoreCase(""))){
//			localEdges.add(edge2.getIdentifier());
//			edges.put(edge2.getIdentifier(), edge2);
//			}
			
		}

	}

	
	public Node getNode(String id) {

		return (Node) nodes.get(id);
	}

	
	public void setEdge(Edge edge) {
		edges.put(edge.getIdentifier(), edge);
	}

	
	public Edge getEdge(String id) {
		return (Edge) edges.get(id);
	}

	
	public String getName() {
		return name;
	}

	
	public void setName(String name) {
		this.name = name;
	}

}
