/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: Graph2.java,v 1.3 2006/03/19 11:58:11 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.util.graph;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Iterator;
/**
 * @author gehrke, gormanns, siebert
 * 
 */
public class Graph2 implements IGraph2, Serializable {
    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	String name;

    Hashtable nodes;

    Hashtable edges;

    public Graph2() {

        name = "Phylogenetic Tree";
        nodes = new Hashtable();
        edges = new Hashtable();
    }

    public Graph2(String name) {

        this.name = name;
        nodes = new Hashtable();
        edges = new Hashtable();

    }

    public void setNodes(Hashtable nodes) {
        this.nodes = (Hashtable) nodes.clone();

    }

    public Hashtable getNodes() {
        return nodes;
    }

    public void setEdges(Hashtable edges) {
        this.edges = (Hashtable) edges.clone();
    }

    public Hashtable getEdges() {
        return edges;
    }
    public void joinTrees(Graph tree1, Graph tree2) {

        Hashtable nodesTree1 = (Hashtable) tree1.getNodes().clone();
        Node localNode;
        Node2 localNode2 =new Node2();
        Iterator it = nodesTree1.keySet().iterator();
        
        while(it.hasNext()){
            
            localNode = (Node)nodesTree1.get(it.next());
            localNode2.setIdentifier(localNode.getIdentifier());
            localNode2.setEdgesIncoming((ArrayList)localNode.getEdgesIncoming().clone());
            localNode2.setEdgesOutgoing((ArrayList)localNode.getEdgesOutgoing().clone());
            localNode2.setCounter(0,localNode.getCounter());
            this.nodes.put(localNode2.getIdentifier(), localNode2);
            
            
        }
        
      //  Hashtable nodeStack= new Hashtable();
        
        
        
//        Hashtable nodesTree2 = tree2.getNodes();
//
//        // Hashtable ed=(Hashtable)tree1.getEdges().clone();
//
//        Node root = (Node) nodesTree2.get("root");
//        ArrayList rootEdges = root.getEdgesOutgoing();
//      
//        for (int i = 0; i < rootEdges.size(); i++) {
//
//            Edge localEdge = (Edge) rootEdges.get(i);
//            String localNodeId = (String) localEdge.getNode(1);
//            if (nodesTree1.contains(localNodeId)) {
//
//                Node2 newNode = new Node2();
//                newNode.setCounter(0, ((Node) nodesTree1.get(localNodeId))
//                        .getCounter());
//                newNode.setCounter(1, ((Node) nodesTree2.get(localNodeId))
//                        .getCounter());
//                newNode.setIdentifier(localNodeId);
//                newNode.setEdgesIncoming((ArrayList) (((Node) nodesTree1
//                        .get(localNodeId)).getEdgesIncoming().clone()));
//                this.nodes.put(localNodeId, newNode);
//                
//                
//            }
//        }
    }

    public void addNode(String identifier, String successor,
            String predecessor, int group) {
        try {
            Node2 tmpNode = (Node2) nodes.get(identifier);
            tmpNode.increaseCounter(group);
            nodes.put(identifier, tmpNode);

        } catch (NullPointerException npe) {
            Node2 node = new Node2();
            node.setIdentifier(identifier);

            // Edge edge2 = new Edge();
            // edge2.setIdentifier(identifier + "_" + successor);
            // edge2.setNodes(new String[] { identifier, successor });

            ArrayList localEdges = new ArrayList();

            // Edge edge1 = new Edge();
            // edge1.setIdentifier(predecessor + "_" + identifier);

            // localEdges.add(edge1.getIdentifier());

            // edges.put(edge1.getIdentifier(), edge1);

            try {
                Node2 tmpNode = (Node2) nodes.get(predecessor);
                Edge edge2 = new Edge();
                edge2.setIdentifier(predecessor + "_" + identifier);
                edge2.setNodes(new String[] { predecessor, identifier });
                tmpNode.getEdgesOutgoing().add(edge2);
                localEdges.add(edge2);// checken ob
                // referenzen
                // passen!!!
                edges.put(edge2.getIdentifier(), edge2);
                nodes.put(tmpNode.getIdentifier(), tmpNode);
                node.setEdgesIncoming(localEdges);
                node.increaseCounter(group);

                nodes.put(node.getIdentifier(), node);
            }

            catch (NullPointerException e) {

                Node2 tmpNode = new Node2();
                tmpNode.setIdentifier("root");
                Edge edge2 = new Edge();
                edge2.setIdentifier("root" + "_" + identifier);
                edge2.setNodes(new String[] { "root", identifier });
                ArrayList rootEdges = new ArrayList();
                rootEdges.add(edge2);
                tmpNode.setEdgesOutgoing(rootEdges);
                edges.put(edge2.getIdentifier(), edge2);
                // Edge edge2 = new Edge();
                // edge2.setIdentifier("root"+"_"+successor);
                // tmpNode.getEdges().add(edge2);

                // checken ob
                // referenzen
                // passen!!!
                nodes.put(tmpNode.getIdentifier(), tmpNode);

                node.setEdgesIncoming(localEdges);
                node.increaseCounter(group);

                nodes.put(node.getIdentifier(), node);
            }

            // if(!(successor.equalsIgnoreCase(""))){
            // localEdges.add(edge2.getIdentifier());
            // edges.put(edge2.getIdentifier(), edge2);
            // }

        }

    }

    public Node2 getNode(String id) {

        return (Node2) nodes.get(id);
    }

    public void setEdge(Edge edge) {
        edges.put(edge.getIdentifier(), edge);
    }

    public Edge getEdge(String id) {
        return (Edge) edges.get(id);
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

}
