/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: Node2.java,v 1.3 2006/03/19 11:58:11 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.util.graph;

import java.io.Serializable;
import java.util.ArrayList;

/**
 * @author gormanns
 * 
 */
public class Node2 implements INode, Serializable {

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private String identifier;

    private int counterGroup1 = 0;

    private int counterGroup2 = 0;

    private ArrayList edgesOutgoing;

    private ArrayList edgesIncoming;

    public Node2() {
        edgesOutgoing = new ArrayList();
        edgesIncoming = new ArrayList();
        identifier = "";
    }

    public String getIdentifier() {
        return identifier;
    }

    public void setIdentifier(String id) {
        this.identifier = id;
    }

    public void setEdgesOutgoing(ArrayList edges) {

        this.edgesOutgoing = (ArrayList) edges.clone();
    }

    public ArrayList getEdgesOutgoing() {

        return this.edgesOutgoing;
    }

    public void setEdgesIncoming(ArrayList edges) {

        this.edgesIncoming = (ArrayList) edges.clone();
    }

    public ArrayList getEdgesIncoming() {

        return this.edgesIncoming;
    }

    public void setCounter(int group, int value) {

        if (group == 0) {
            this.counterGroup1 = value;
        } else {
            if (group == 1) {
                this.counterGroup2 = value;
            } else {
                throw new IllegalArgumentException();
            }
        }
    }

    public int getCounter(int group) throws IllegalArgumentException {
        if (group == 0) {
            return counterGroup1;
        } else {
            if (group == 1) {
                return counterGroup2;
            } else {
                throw new IllegalArgumentException();
            }
        }

    }

    public void increaseCounter(int group) throws IllegalArgumentException {
        if (group == 0) {
            counterGroup1++;
        } else {
            if (group == 1) {
                counterGroup2++;
            } else {
                throw new IllegalArgumentException();
            }
        }

    }

}
