/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: Viewer.java,v 1.4 2006/03/19 11:57:58 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.vis;


import java.awt.Component;
import java.awt.Image;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JFrame;
import javax.swing.UIManager;

import org.apache.log4j.Logger;

/**
 * Creates a single frame and shows the graphic generated by R 
 * FIXME pop-up geht erst auf wenn nach dem rechten Mouse klick die mouse bewegt wird
 * 
 */

public class Viewer extends JFrame implements MouseListener {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	protected IVisualisation visual;
	public Image image, image2;
	protected int imgSizeX = 800;
	protected int imgSizeY = 800;
	protected ViewerPopupMenu popup;
	protected ViewerMenuBar menubar;
	
	
	Logger logger = Logger.getLogger(Viewer.class);
	
	public Viewer(Image image, IVisualisation visual, String title) {
	    logger = Logger.getLogger(Viewer.class);
	    
	    try {
			String os = System.getProperty("os.name");
            if (os.matches(".*?Windows.*")) {
            	UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
            }
		}
		catch(Exception e) {
			logger.warn(e);
		}	
	    
	    
	    this.image = image;
		this.visual = visual;
//		if (! this.visual.performPlottingCalled) {
//		    logger.error("You must call the method performPlotting of your plot object frist");
//		}
		
		//--
		 // WindowListener
	    addWindowListener(new WindowAdapter() {
	        public void windowClosing(WindowEvent e) {
	                    //System.exit(0);
	        		dispose();
	        }
	    });	
	    
	    
		menubar = new ViewerMenuBar(visual, title);
		this.setJMenuBar(menubar);
		ViewerImagePanel panel = new ViewerImagePanel(image,visual,title);
		this.getContentPane().add(panel);
		
		//--
		popup = new ViewerPopupMenu( visual, title);

		
		
		/*image2 = image.getScaledInstance(imgSizeX, imgSizeY, Image.SCALE_SMOOTH);
		
		MediaTracker mediaTracker = new MediaTracker(this);
		mediaTracker.addImage(image2, 0);
		try {
			mediaTracker.waitForID(0);
		} catch (InterruptedException e) {
			logger.error(e);
		}*/
		this.addMouseListener(this);
		//setSize(image2.getWidth(null), image2.getHeight(null));
		setSize(imgSizeX, imgSizeY);
		
		if (title == null) {
			setTitle(this.getClass().getName());
		} else {
			setTitle(title);
		}
		
		setVisible(true);
		this.repaint();
		//
	}
	/*
	public void paint(Graphics graphics) {
		graphics.drawImage(image2, 0, 0, getWidth(), getHeight(), null);
	}*/
	
	
	public void mouseClicked(MouseEvent e) {
		if (e.getSource() == this && e.getButton() == MouseEvent.BUTTON3) {
			popup.show((Component) this, e.getX(), e.getY());
		}
		
	}

	public void mouseEntered(MouseEvent e) {
	}
	public void mouseExited(MouseEvent e) {
	}
	public void mouseReleased(MouseEvent e) {
	}
	public void mousePressed(MouseEvent e) {
	}
}
