/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: ViewerImagePanel.java,v 1.4 2006/03/19 11:57:58 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.vis;

import java.awt.Graphics;
import java.awt.Image;
import java.awt.MediaTracker;

import javax.swing.JPanel;

import org.apache.log4j.Logger;





/**
 * @author schrader
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ViewerImagePanel extends JPanel{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public Image image,image2;
	protected IVisualisation visual;
	protected int imgSizeX = 800;
	protected int imgSizeY = 800;
	
	public static Logger logger = Logger.getLogger(ViewerImagePanel.class);
	
	public ViewerImagePanel(Image image, IVisualisation visual, String title){
		this.image= image;
		this.visual = visual;
		image2 = image.getScaledInstance(imgSizeX, imgSizeY, Image.SCALE_SMOOTH);
		
		setSize(image2.getWidth(null), image2.getHeight(null));
	}
	
	
	public void paint(Graphics graphics) {
		if ( image2 != null )
        {
        MediaTracker tracker;
        try
           {
           // wait until image is fully loaded.
           // and so that paint will be instantaneous, rather than gradual as
           // the image arrives.
           // MediaTracker notifies of progress via our Component.ImageObsever interface
           tracker = new MediaTracker( this );
           tracker.addImage( image2, 0 );
           tracker.waitForID( 0 );
           }
        catch ( InterruptedException e )
           {
        	logger.warn(e);
        	//logger.debug("ViewerImagePanel"+e);
           }
        }
     // image is now ready, let's paint it
    
		graphics.drawImage(image2, 0, 0, getWidth(), getHeight(), null);
	}
}
