/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: ViewerMenuBar.java,v 1.3 2006/03/19 11:57:58 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.vis;

import java.awt.event.KeyEvent;

import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;

import org.apache.log4j.Logger;

/**
 * Creates a menu when rightclick in graphic and opens a dialog schmidt :added eps and emf format schmidt :save to user.home instead of tmp dir set
 * model true title as default filename
 *  
 */

public class ViewerMenuBar extends JMenuBar {
  

  /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
Logger logger = Logger.getLogger(this.getClass().getName());

 
  public ViewerMenuBar(IVisualisation visual, String title) {
    //this.sourceFilename = sourceFilename;
    
    String os = System.getProperty("os.name");
    boolean WINDOWS;
    if (os.matches(".*?Windows.*")) {
      WINDOWS = true;
    } else {
      WINDOWS = false;
    }
     
    JMenu menu = new JMenu("File-Actions");
    menu.setMnemonic(KeyEvent.VK_A);
    menu.getAccessibleContext().setAccessibleDescription(
            "Image Save etc.");
    this.add(menu);
    
    
    ViewerSaving al = new ViewerSaving(visual,title);
    
    JMenuItem menuItem = new JMenuItem("Save Data to...");
    menuItem.addActionListener(al);
    menu.add(menuItem);

    menuItem = new JMenuItem("Save As EPS...");
    menuItem.addActionListener(al);
    menu.add(menuItem);

    menuItem = new JMenuItem("Save As PNG...");
    menuItem.addActionListener(al);
    menu.add(menuItem);

    menuItem = new JMenuItem("Save As EMF...");
    menuItem.addActionListener(al);
    if (!WINDOWS) {
      menuItem.setEnabled(false);
    }
    menu.add(menuItem);

    menuItem = new JMenuItem("Save all");
    menuItem.addActionListener(al);
    menu.add(menuItem);
    menu.addSeparator();

    menuItem = new JMenuItem("Show data");
    menuItem.addActionListener(al);
    menu.add(menuItem);

    menuItem = new JMenuItem("Send to lpr");
    menuItem.addActionListener(al);
    menu.add(menuItem);
    this.add(menu);

  }


}
