/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: Gp_PlotHist.java,v 1.3 2006/03/19 11:58:06 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.vis.generic;

import prompt.vis.VisualisationGnuplot;

/**
 * Malt ein histogram,
*Input: 2spalten, beide numerisch, erste Spalte ist Mittelpunkt der Histogramintervalle, 
*zweite Spalte ist die Hoehe(Frequency/Y-Achse) der Bars
*
*@author schrader,tschmidt
 */
public class Gp_PlotHist extends VisualisationGnuplot{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/* (non-Javadoc)
	 * @see de.tum.binfo.jdrm.JobTemplate#hashCode()
	 */
	public int hashCode() {
		return 0;
	}

	/* (non-Javadoc)
	 * @see de.tum.binfo.jdrm.JobTemplate#run()
	 */
	public void run() throws Exception {
		String gcmds = "plot \"#datafile\" using 1:2 with boxes; replot;";
		performPlotting(gcmds);
	}

}
