/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: Test_Gp_PlotHist.java,v 1.4 2006/03/19 11:58:04 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.vis.generic;



import org.apache.log4j.Logger;

import prompt.engine.EngineResults;
import prompt.ui.DataTable;
import tschmidt.ginterface.GCfgCheck;
import tschmidt.ginterface.GException;
import tschmidt.ginterface.vis.Par;

public class Test_Gp_PlotHist {
	

	public static void main(String[] args) throws GException {
	
        Logger logger = Logger.getLogger(Test_Gp_PlotHist.class);


		StringBuffer data = new StringBuffer();
		data.append("col1\tcol2\n");
		for (int i = 0; i < 10; i++) {
			data.append((i*10)+"\t"+(Math.random()*20)+"\n");
		}
		
		EngineResults er = new EngineResults();
		try {
			er.setResult(data.toString(),null,null,false,"ResultType");
			er.setResultDescription("<html>Fancy new  Data from  TravianBacterium and the worlds most wanted and secretly hidden fantastic gigantic fabulous E.Coli</html>");
		} catch (Exception e1) {
            logger.error(e1);
		}
		DataTable dataTable = new DataTable(er,"Title");
		
			dataTable.showTable();
		
		GCfgCheck.checkG();
		Par gpar = new Par();
		//gpar.set_xrange("[0:60]");
		gpar.setTitle("GnuplotAutomatic");
		gpar.set_Labels("Ph-Value","Amount");
		
		Gp_PlotHist pd = new Gp_PlotHist();
		pd.init(er);
		pd.setPar(gpar);
		
		try {
			pd.run();
		} catch (Exception e) {
            logger.error(e);
		}
		pd.showGraphic();	
	}
}
