/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: AaDistributionBoxPlot.java,v 1.4 2006/04/12 12:33:16 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.vis.seqproperties;

import prompt.engine.IEngineResults;
import prompt.ui.AaDialog;
import prompt.util.AALetter1To3;
import prompt.vis.VisualisationR;
import tschmidt.rinterface.RException;


public class AaDistributionBoxPlot extends VisualisationR {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public String acidToPlot;

	
	
	/**
	 * @param data
	 */
	public void init(IEngineResults data) {
		super.init(data);
	}

	public void init(IEngineResults data, String acidToPlot)
		throws Exception {
		super.init(data);
		this.acidToPlot = acidToPlot;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	public int hashCode() {

		return 0;
	}

	/* (non-Javadoc)
	 * @see de.tum.binfo.jdrm.JobTemplate#run()
	 */
	public void run() throws RException {
		if (acidToPlot == null) {
			String[] elements =
				AaDialog.getElementsFromDistributionInBoth(this.data, 1);
			AaDialog aaDialog = new AaDialog();
			acidToPlot = aaDialog.showAaDialog(elements);
		}

		if (acidToPlot != null) {

			String rcmds =
				"boxplot(data[data$AA==\""
					+ acidToPlot
					+ "\" & data$DATASET==\"setA\",3],data[data$AA==\""
					+ acidToPlot
					+ "\" & data$DATASET==\"setB\",3],main=\""
					+ (acidToPlot)   //AALetter1To3.getLongAminoAcidName
					+ "\", names=c(\""
					+ data.getDesc1()
					+ "\",\""
					+ data.getDesc2()
					+ "\"))\n";
			performPlotting(rcmds);
		}
	}

}
