/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: AaFrequencesDiffPlot.java,v 1.4 2006/03/19 11:58:06 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.vis.seqproperties;


import prompt.engine.IEngineResults;
import prompt.vis.VisualisationR;
import tschmidt.rinterface.RException;


public class AaFrequencesDiffPlot extends VisualisationR {
	
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	protected String colorList;
	/**
	 * @param resultFreq
	 * @throws Exception
	 */
	public void init(IEngineResults resultFreq, String colorList)
		throws Exception {
		super.init(resultFreq);
		this.colorList = colorList;
	}
	public void init(IEngineResults data) {
		super.init(data);
	}

	public String color = "green";

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	public int hashCode() {
	
		return 0;
	}

	/* (non-Javadoc)
	 * @see de.tum.binfo.jdrm.JobTemplate#run()
	 */
	public void run() throws RException {
		
		String legend = "legend(100,max(m)+0.2,c(\""
			+ "significant"
			+ "\",\""
			+ "not significant"
			+ "\"), fill=c(\""
			+ "red"
			+ "\",\""
			+ "green"
			+ "\"))";
		
		if (colorList == null) {
			colorList = "\"" + color + "\"";
		
			legend = "";
		}

		if (titleWindow==null) {
			titleWindow="";
		}
		
		String rcmds =
			"dataPlot=data[5,]\n"
				+ "m=as.matrix(dataPlot)\n"
				+ "barplot(m, beside=TRUE, main=\""+titleWindow+"\", col="
				+ colorList
				+ ", las=3, ylab=\"Difference in Frequency in %\",ylim=c(min(m)+(min(m)/3),max(m)+(max(m)/3)),width=c(5,.55),space=c(1.25,.75))\n"
				+ legend +
						"\n";
		//logger.debug(rcmds);
		performPlotting(rcmds);
	}
}
