/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: AaFrequencesPlot.java,v 1.3 2006/03/19 11:58:06 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.vis.seqproperties;

import prompt.engine.IEngineResults;
import prompt.vis.VisualisationR;
import tschmidt.rinterface.RException;



public class AaFrequencesPlot extends VisualisationR {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;


	public void init(IEngineResults result)  {
		super.init(result);
	}

	public String color1 = "green";
	public String color2 = "blue";

	/* (non-Javadoc)
	 * @see de.tum.binfo.jdrm.JobTemplate#hashCode()
	 */
	public int hashCode() {
		return 0;
	}

	/* (non-Javadoc)
	 * @see de.tum.binfo.jdrm.JobTemplate#run()
	 */
	public void run() throws RException {
		if (titleWindow==null) {
			titleWindow=this.getClass().getName();
		}
		String rcmds =
			"dataPlot=data[c(3,4),]\n"
				+ "m=as.matrix(dataPlot)\n"
				+ "barplot(m,beside=TRUE,main=\""+titleWindow+"\", ylab=\"Frequency in %\",ylim=c(0,max(m)+3), las=3, col=c(\""
				+ color1
				+ "\", \""
				+ color2
				+ "\"))\n"
				+ "legend(35,max(m)+3,c(\""
				+ data.getDesc1()
				+ "\",\""
				+ data.getDesc2()
				+ "\"), fill=c(\""
				+ color1
				+ "\",\""
				+ color2
				+ "\"))\n";
		performPlotting(rcmds);

	}
}
