/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: PIComparePlot.java,v 1.5 2006/03/19 11:58:07 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.vis.seqproperties;

import org.apache.log4j.Logger;

import prompt.engine.IEngineResults;
import prompt.vis.VisualisationR;
import tschmidt.rinterface.RException;
import tschmidt.rinterface.vis.Barplot;
import tschmidt.rinterface.vis.Par;



public class PIComparePlot extends VisualisationR {
	
  /**
	 * 
	 */
	private static final long serialVersionUID = 1L;

public Barplot barplot = new Barplot();
	
	/*String s = (String) JOptionPane.showInputDialog
	(null, "max y-Wert eingeben", "90");
*/
  Logger logger = Logger.getLogger(PIComparePlot.class);
  
	protected String colorList;
	
    public PIComparePlot() {
    }
	
    
    protected void doSettings()
    {
      par.setLas(Par.LAS_PERPENDICULAR);
      
      par.setMgp_axis_title(5f); //xlab und ylab weiter weg von der Plot region
      par.setMar_left(6); //links mehr platz
      par.setMar_bottom(9); //unten mehr platz
    
    
      title.setXlab("pI (lower border)");
      title.setSub("[X] indicates significant differences");
      title.setYlab("relative fraction");
      
      barplot.setFirst("m, cex.names=1, space=c(0,2), ylab=\"\",  beside=TRUE,"  
          + "legend.text=c(\"" + data.getDesc1() + "\",\"" + data.getDesc2()
          + "\",\"Difference\")");
      
      barplot.setYlim("ymin","ymax");
    }
    
    public void init(IEngineResults resultFreq) {
      super.init(resultFreq);
      doSettings();
    }
	/**
	 * @param data
	 * @throws Exception
	 */
	public void init(IEngineResults data, String colorList)
		throws Exception {
		super.init(data);
		this.colorList = colorList;
		doSettings();
	}




    public String color = "green";

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	public int hashCode() {
	
		return 0;
	}

	/* (non-Javadoc)
	 * @see de.tum.binfo.jdrm.JobTemplate#run()
	 */
	public void run() throws RException {
		if (colorList == null) {
			colorList = "\"" + color + "\"";
		}
		
	    logger.debug("par:" + par);
	    logger.debug("title:" + title);
	    logger.debug("barplot:"+barplot);
	    
		String rcmds = "dataPlot=data[c(2,4,5),]\n"
	        + "m=as.matrix(dataPlot)\n"
	        + "ymin=min(m)+( min(m)*0.3)\n"
	        + "ymax=max(m)+( max(m)*0.3)\n"
	        + barplot+"\n"; //box()
		
//		String rcmds =
//			"dataPlot=data[c(2,4,5),]\n"
//				+ "m=as.matrix(dataPlot)\n"
//				+ "barplot(m, cex.names=0.7, ylab=\"Fraction of the corresponding dataset\", xlab=\"pI (rounded)\", beside=TRUE,"
//				+ "legend.text=c(\""
//				+ data.getDesc1()
//				+ "\",\""
//				+ data.getDesc2()
//				+ "\",\"Difference\"))\n";
		//logger.debug(rcmds);
		performPlotting(rcmds);
	}
  /* (non-Javadoc)
   * @see prompt.vis.IVisualisationR#init(de.tum.binfo.proj.engine.IEngineResults)
   */

}
