/* ------------------------------------------------------------------------------- *
 * This file is part of PROMPT - a Protein Mapping and Comparison Tool             *
 * ------------------------------------------------------------------------------- *
 * Copyright (C) Thorsten Schmidt                             t.schmidt@wzw.tum.de *
 *               Technische Universitt Mnchen                                    *
 *               Wissenschaftszentrum Weihenstephan                                *
 *               Am Forum 1                                                        *
 *               85354 Freising                                                    *
 *               Germany                                                           *
 *                                                                                 *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY *
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A *
 * PARTICULAR PURPOSE.  See the license file for more details.                     *
 *                                                                                 *
 * ------------------------------------------------------------------------------- *
 * $Id: PIabsHist.java,v 1.4 2006/03/19 11:58:07 schmidt Exp $
 * ------------------------------------------------------------------------------- *
 * Author: Thorsten Schmidt <t.schmidt@wzw.tum.de>                                 *
 * ------------------------------------------------------------------------------- */
package prompt.vis.seqproperties;

import org.apache.log4j.Logger;

import prompt.engine.IEngineResults;
import prompt.vis.VisualisationR;
import tschmidt.rinterface.vis.Hist;

/**
 * @author schmidt
 *
 */
public class PIabsHist extends VisualisationR {


  /**
	 * 
	 */
	private static final long serialVersionUID = 1L;

public PIabsHist() {
    super();
  }

  public Hist hist = new Hist();
  
  public void init(IEngineResults data) {
    super.init(data);
    
    title.setXlab("|pI-7|");
    title.setYlab("Relative Frequency");
    
    hist.setFirst("m, probability=T,breaks=7, xlab=\"\",  ylab=\"\",  main=\"\" ");
    
   
  }
  
  /* (non-Javadoc)
   * @see java.lang.Object#hashCode()
   */
  public int hashCode() {
    return 0;
  }

  /* (non-Javadoc)
   * @see de.tum.binfo.jdrm.JobTemplate#run()
   */
  public void run() throws Exception {
      Logger logger = Logger.getLogger(this.getClass());
    logger.debug("par:" + par);
    logger.debug("title:" + title);
    logger.debug("hist:"+hist);
    
    String rcmds = "m=as.matrix(data)\n" + hist + "\n";
    performPlotting(rcmds);

  }

}
